Linux mail.vriendennsm.nl 6.1.0-51-amd64 #1 SMP PREEMPT_DYNAMIC Debian 6.1.177-1 (2026-07-16) x86_64
Apache/2.4.68 (Debian)
Server IP : 217.154.75.17 & Your IP : 216.73.216.195
Domains :
Cant Read [ /etc/named.conf ]
User : www-data
Terminal
Auto Root
Create File
Create Folder
Localroot Suggester
Backdoor Destroyer
Readme
/
usr /
bin /
Delete
Unzip
Name
Size
Permission
Date
Action
[
66.89
KB
-rwxr-xr-x
2022-09-20 15:27
aa-enabled
18.23
KB
-rwxr-xr-x
2023-02-14 11:49
aa-exec
18.23
KB
-rwxr-xr-x
2023-02-14 11:49
aa-features-abi
18.23
KB
-rwxr-xr-x
2023-02-14 11:49
ab
58.42
KB
-rwxr-xr-x
2026-06-12 05:08
addpart
30.31
KB
-rwxr-xr-x
2024-11-21 20:01
apropos
51.29
KB
-rwxr-xr-x
2023-03-12 22:23
apt
18.31
KB
-rwxr-xr-x
2023-05-25 14:11
apt-cache
86.38
KB
-rwxr-xr-x
2023-05-25 14:11
apt-cdrom
22.38
KB
-rwxr-xr-x
2023-05-25 14:11
apt-config
26.31
KB
-rwxr-xr-x
2023-05-25 14:11
apt-extracttemplates
22.39
KB
-rwxr-xr-x
2023-05-25 14:11
apt-ftparchive
270.39
KB
-rwxr-xr-x
2023-05-25 14:11
apt-get
50.38
KB
-rwxr-xr-x
2023-05-25 14:11
apt-key
27.32
KB
-rwxr-xr-x
2023-05-25 14:11
apt-listchanges
11.96
KB
-rwxr-xr-x
2021-03-28 11:06
apt-mark
58.38
KB
-rwxr-xr-x
2023-05-25 14:11
apt-sortpkgs
38.32
KB
-rwxr-xr-x
2023-05-25 14:11
arch
42.86
KB
-rwxr-xr-x
2022-09-20 15:27
aria_chk
5.34
MB
-rwxr-xr-x
2026-06-27 11:11
aria_dump_log
5.14
MB
-rwxr-xr-x
2026-06-27 11:11
aria_ftdump
5.15
MB
-rwxr-xr-x
2026-06-27 11:11
aria_pack
5.18
MB
-rwxr-xr-x
2026-06-27 11:11
aria_read_log
5.3
MB
-rwxr-xr-x
2026-06-27 11:11
awk
696.44
KB
-rwxr-xr-x
2023-02-19 13:30
b2sum
58.98
KB
-rwxr-xr-x
2022-09-20 15:27
base32
46.89
KB
-rwxr-xr-x
2022-09-20 15:27
base64
46.89
KB
-rwxr-xr-x
2022-09-20 15:27
basename
42.83
KB
-rwxr-xr-x
2022-09-20 15:27
basenc
54.89
KB
-rwxr-xr-x
2022-09-20 15:27
bash
1.21
MB
-rwxr-xr-x
2026-05-07 20:33
bashbug
6.7
KB
-rwxr-xr-x
2026-05-07 20:33
bunzip2
38.3
KB
-rwxr-xr-x
2022-09-19 02:54
busctl
90.5
KB
-rwxr-xr-x
2026-04-27 19:48
bzcat
38.3
KB
-rwxr-xr-x
2022-09-19 02:54
bzcmp
2.17
KB
-rwxr-xr-x
2022-09-19 02:54
bzdiff
2.17
KB
-rwxr-xr-x
2022-09-19 02:54
bzegrep
3.69
KB
-rwxr-xr-x
2022-09-19 02:54
bzexe
4.78
KB
-rwxr-xr-x
2021-11-27 12:25
bzfgrep
3.69
KB
-rwxr-xr-x
2022-09-19 02:54
bzgrep
3.69
KB
-rwxr-xr-x
2022-09-19 02:54
bzip2
38.3
KB
-rwxr-xr-x
2022-09-19 02:54
bzip2recover
14.23
KB
-rwxr-xr-x
2022-09-19 02:54
bzless
1.27
KB
-rwxr-xr-x
2022-09-19 02:54
bzmore
1.27
KB
-rwxr-xr-x
2022-09-19 02:54
c_rehash
6.76
KB
-rwxr-xr-x
2026-06-06 19:56
captoinfo
90.34
KB
-rwxr-xr-x
2023-05-07 14:33
cat
42.98
KB
-rwxr-xr-x
2022-09-20 15:27
catman
42.77
KB
-rwxr-xr-x
2023-03-12 22:23
certbot
14.79
MB
-rwxr-xr-x
2026-05-10 10:28
cgi-fcgi
18.08
KB
-rwxr-xr-x
2025-05-26 18:18
chage
78.49
KB
-rwxr-sr-x
2025-12-14 14:00
chardet
221
B
-rwxr-xr-x
2022-12-26 14:42
chardetect
221
B
-rwxr-xr-x
2022-12-26 14:42
chattr
14.24
KB
-rwxr-xr-x
2025-06-06 17:12
chcon
67.11
KB
-rwxr-xr-x
2022-09-20 15:27
checkgid
14.23
KB
-rwxr-xr-x
2026-06-12 05:08
chfn
61.2
KB
-rwsr-xr-x
2025-12-14 14:00
chgrp
67.05
KB
-rwxr-xr-x
2022-09-20 15:27
chmod
62.98
KB
-rwxr-xr-x
2022-09-20 15:27
choom
54.31
KB
-rwxr-xr-x
2024-11-21 20:01
chown
71.05
KB
-rwxr-xr-x
2022-09-20 15:27
chrt
66.31
KB
-rwxr-xr-x
2024-11-21 20:01
chsh
51.64
KB
-rwsr-xr-x
2025-12-14 14:00
cksum
139.05
KB
-rwxr-xr-x
2022-09-20 15:27
clear
14.24
KB
-rwxr-xr-x
2023-05-07 14:33
clear_console
14.15
KB
-rwxr-xr-x
2026-05-07 20:33
cloud-id
972
B
-rwxr-xr-x
2026-06-01 19:13
cloud-init
976
B
-rwxr-xr-x
2026-06-01 19:13
cloud-init-per
2.06
KB
-rwxr-xr-x
2022-11-23 21:17
cloud-localds
7.21
KB
-rwxr-xr-x
2022-06-03 10:51
cmp
50.95
KB
-rwxr-xr-x
2023-02-03 19:00
col
34.31
KB
-rwxr-xr-x
2024-11-21 20:01
colcrt
14.31
KB
-rwxr-xr-x
2024-11-21 20:01
colrm
30.31
KB
-rwxr-xr-x
2024-11-21 20:01
column
54.31
KB
-rwxr-xr-x
2024-11-21 20:01
comm
46.92
KB
-rwxr-xr-x
2022-09-20 15:27
compose
18.06
KB
-rwxr-xr-x
2021-11-29 13:07
corelist
15.01
KB
-rwxr-xr-x
2025-08-29 12:09
cp
147.61
KB
-rwxr-xr-x
2022-09-20 15:27
cpan
8.16
KB
-rwxr-xr-x
2025-08-29 12:09
cpan5.36-x86_64-linux-gnu
8.18
KB
-rwxr-xr-x
2025-08-29 12:09
cpio
158.56
KB
-rwxr-xr-x
2022-09-14 19:45
csplit
119.17
KB
-rwxr-xr-x
2022-09-20 15:27
ctstat
26.59
KB
-rwxr-xr-x
2023-05-22 13:19
curl
274.22
KB
-rwxr-xr-x
2026-05-08 14:16
cut
46.98
KB
-rwxr-xr-x
2022-09-20 15:27
cvtsudoers
337.19
KB
-rwxr-xr-x
2026-04-11 12:01
dash
122.7
KB
-rwxr-xr-x
2023-01-05 13:20
date
119.05
KB
-rwxr-xr-x
2022-09-20 15:27
dbilogstrip
1.35
KB
-rwxr-xr-x
2026-06-09 15:14
dbiprof
6.06
KB
-rwxr-xr-x
2026-06-09 15:14
dbiproxy
5.27
KB
-rwxr-xr-x
2026-06-09 15:14
dbus-cleanup-sockets
14.22
KB
-rwxr-xr-x
2023-09-16 10:03
dbus-daemon
238.56
KB
-rwxr-xr-x
2023-09-16 10:03
dbus-monitor
26.23
KB
-rwxr-xr-x
2023-09-16 10:03
dbus-run-session
14.23
KB
-rwxr-xr-x
2023-09-16 10:03
dbus-send
30.22
KB
-rwxr-xr-x
2023-09-16 10:03
dbus-update-activation-environment
14.22
KB
-rwxr-xr-x
2023-09-16 10:03
dbus-uuidgen
14.22
KB
-rwxr-xr-x
2023-09-16 10:03
dd
87.15
KB
-rwxr-xr-x
2022-09-20 15:27
deb-systemd-helper
23.79
KB
-rwxr-xr-x
2022-07-13 19:55
deb-systemd-invoke
6.09
KB
-rwxr-xr-x
2025-08-20 18:56
debconf
2.79
KB
-rwxr-xr-x
2023-01-08 21:50
debconf-apt-progress
11.27
KB
-rwxr-xr-x
2023-01-08 21:50
debconf-communicate
608
B
-rwxr-xr-x
2023-01-08 21:50
debconf-copydb
1.68
KB
-rwxr-xr-x
2023-01-08 21:50
debconf-escape
647
B
-rwxr-xr-x
2023-01-08 21:50
debconf-set-selections
2.92
KB
-rwxr-xr-x
2023-01-08 21:50
debconf-show
1.78
KB
-rwxr-xr-x
2023-01-08 21:50
debianbts
217
B
-rwxr-xr-x
2022-12-08 11:34
decodemail
30.7
KB
-rwxr-xr-x
2023-03-03 16:00
delpart
30.31
KB
-rwxr-xr-x
2024-11-21 20:01
devdump
180.17
KB
-rwxr-xr-x
2022-06-24 14:56
df
99.8
KB
-rwxr-xr-x
2022-09-20 15:27
dh_bash-completion
4.31
KB
-rwxr-xr-x
2021-08-28 15:26
dh_installxmlcatalogs
9.22
KB
-rwxr-xr-x
2019-02-27 00:18
dh_perl_dbi
1.17
KB
-rwxr-xr-x
2026-06-09 15:14
dh_perl_openssl
1.53
KB
-rwxr-xr-x
2022-05-01 18:31
diff
151.58
KB
-rwxr-xr-x
2023-02-03 19:00
diff3
67.14
KB
-rwxr-xr-x
2023-02-03 19:00
dir
147.8
KB
-rwxr-xr-x
2022-09-20 15:27
dircolors
50.92
KB
-rwxr-xr-x
2022-09-20 15:27
dirmngr
586.13
KB
-rwxr-xr-x
2026-01-01 14:54
dirmngr-client
106.87
KB
-rwxr-xr-x
2026-01-01 14:54
dirname
38.83
KB
-rwxr-xr-x
2022-09-20 15:27
dirsplit
16.74
KB
-rwxr-xr-x
2006-11-25 23:13
dmesg
86.58
KB
-rwxr-xr-x
2024-11-21 20:01
dnsdomainname
22.15
KB
-rwxr-xr-x
2022-12-19 13:33
domainname
22.15
KB
-rwxr-xr-x
2022-12-19 13:33
dotlock
15.07
KB
-rwxr-sr-x
2023-03-03 16:00
dotlock.mailutils
15.07
KB
-rwxr-sr-x
2023-03-03 16:00
dpkg
310.64
KB
-rwxr-xr-x
2026-03-07 12:15
dpkg-deb
166.52
KB
-rwxr-xr-x
2026-03-07 12:15
dpkg-divert
154.55
KB
-rwxr-xr-x
2026-03-07 12:15
dpkg-maintscript-helper
20.71
KB
-rwxr-xr-x
2026-03-07 12:15
dpkg-query
158.58
KB
-rwxr-xr-x
2026-03-07 12:15
dpkg-realpath
4.09
KB
-rwxr-xr-x
2026-03-07 12:15
dpkg-split
126.48
KB
-rwxr-xr-x
2026-03-07 12:15
dpkg-statoverride
62.33
KB
-rwxr-xr-x
2026-03-07 12:15
dpkg-trigger
86.48
KB
-rwxr-xr-x
2026-03-07 12:15
du
171.33
KB
-rwxr-xr-x
2022-09-20 15:27
ec2metadata
8.38
KB
-rwxr-xr-x
2022-06-03 10:51
echo
42.83
KB
-rwxr-xr-x
2022-09-20 15:27
edit
18.06
KB
-rwxr-xr-x
2021-11-29 13:07
editor
280.74
KB
-rwxr-xr-x
2024-05-06 06:10
egrep
41
B
-rwxr-xr-x
2023-01-24 14:43
eject
82.16
KB
-rwxr-xr-x
2024-11-21 20:01
enc2xs
40.96
KB
-rwxr-xr-x
2025-08-29 12:09
encguess
3
KB
-rwxr-xr-x
2025-08-29 12:09
env
47.4
KB
-rwxr-xr-x
2022-09-20 15:27
envsubst
34.31
KB
-rwxr-xr-x
2023-02-26 15:20
eqn
205.42
KB
-rwxr-xr-x
2023-03-07 09:38
ex
3.48
MB
-rwxr-xr-x
2025-02-16 05:23
exonpairs
123.43
KB
-rwxr-xr-x
2020-12-22 13:24
expand
42.92
KB
-rwxr-xr-x
2022-09-20 15:27
expiry
30.45
KB
-rwxr-sr-x
2025-12-14 14:00
expr
115.05
KB
-rwxr-xr-x
2022-09-20 15:27
factor
83.2
KB
-rwxr-xr-x
2022-09-20 15:27
faillog
22.53
KB
-rwxr-xr-x
2025-12-14 14:00
fallocate
34.31
KB
-rwxr-xr-x
2024-11-21 20:01
false
34.83
KB
-rwxr-xr-x
2022-09-20 15:27
fathom
151.24
KB
-rwxr-xr-x
2020-12-22 13:24
fcgistarter
14.23
KB
-rwxr-xr-x
2026-06-12 05:08
fgrep
41
B
-rwxr-xr-x
2023-01-24 14:43
filan
96.02
KB
-rwxr-xr-x
2022-11-06 08:15
file
26.48
KB
-rwxr-xr-x
2023-01-28 18:17
fincore
34.36
KB
-rwxr-xr-x
2024-11-21 20:01
find
219.58
KB
-rwxr-xr-x
2023-01-08 18:07
findmnt
83.59
KB
-rwxr-xr-x
2024-11-21 20:01
flock
34.39
KB
-rwxr-xr-x
2024-11-21 20:01
fmt
46.89
KB
-rwxr-xr-x
2022-09-20 15:27
fold
42.89
KB
-rwxr-xr-x
2022-09-20 15:27
forge
135.21
KB
-rwxr-xr-x
2020-12-22 13:24
free
26.3
KB
-rwxr-xr-x
2022-12-19 06:06
frm
27.23
KB
-rwxr-xr-x
2023-03-03 16:00
frm.mailutils
27.23
KB
-rwxr-xr-x
2023-03-03 16:00
from
22.78
KB
-rwxr-xr-x
2023-03-03 16:00
from.mailutils
22.78
KB
-rwxr-xr-x
2023-03-03 16:00
funzip
22.46
KB
-rwxr-xr-x
2026-08-16 13:50
fuser
39.83
KB
-rwxr-xr-x
2022-12-13 05:27
galera_new_cluster
930
B
-rwxr-xr-x
2026-06-27 11:11
galera_recovery
3.29
KB
-rwxr-xr-x
2026-06-27 11:11
gawk
696.44
KB
-rwxr-xr-x
2023-02-19 13:30
gawkbug
6.54
KB
-rwxr-xr-x
2023-02-19 13:30
genisoimage
631.17
KB
-rwxr-xr-x
2022-06-24 14:56
geqn
205.42
KB
-rwxr-xr-x
2023-03-07 09:38
getconf
26.5
KB
-rwxr-xr-x
2026-04-27 20:14
geteltorito
6.06
KB
-rwxr-xr-x
2022-06-24 14:56
getent
35.47
KB
-rwxr-xr-x
2026-04-27 20:14
getopt
34.31
KB
-rwxr-xr-x
2024-11-21 20:01
gettext
34.31
KB
-rwxr-xr-x
2023-02-26 15:20
gettext.sh
5.07
KB
-rwxr-xr-x
2023-02-26 15:20
gpasswd
86.42
KB
-rwsr-xr-x
2025-12-14 14:00
gpg
1.06
MB
-rwxr-xr-x
2026-01-01 14:54
gpg-agent
425.22
KB
-rwxr-xr-x
2026-01-01 14:54
gpg-connect-agent
154.96
KB
-rwxr-xr-x
2026-01-01 14:54
gpg-wks-server
203
KB
-rwxr-xr-x
2026-01-01 14:54
gpg-zip
3.43
KB
-rwxr-xr-x
2026-01-01 14:54
gpgcompose
910.27
KB
-rwxr-xr-x
2026-01-01 14:54
gpgconf
174.73
KB
-rwxr-xr-x
2026-01-01 14:54
gpgparsemail
34.3
KB
-rwxr-xr-x
2026-01-01 14:54
gpgsm
527.66
KB
-rwxr-xr-x
2026-01-01 14:54
gpgsplit
74.56
KB
-rwxr-xr-x
2026-01-01 14:54
gpgtar
147.52
KB
-rwxr-xr-x
2026-01-01 14:54
gpgv
463
KB
-rwxr-xr-x
2026-01-01 14:54
gpic
220.27
KB
-rwxr-xr-x
2023-03-07 09:38
grep
198.39
KB
-rwxr-xr-x
2023-01-24 14:43
groff
125.45
KB
-rwxr-xr-x
2023-03-07 09:38
grog
2.71
KB
-rwxr-xr-x
2023-03-07 09:38
grops
185.86
KB
-rwxr-xr-x
2023-03-07 09:38
grotty
137.48
KB
-rwxr-xr-x
2023-03-07 09:38
groups
42.89
KB
-rwxr-xr-x
2022-09-20 15:27
growpart
29.19
KB
-rwxr-xr-x
2022-06-03 10:51
grub-editenv
374.23
KB
-rwxr-xr-x
2026-04-01 20:03
grub-file
814.7
KB
-rwxr-xr-x
2026-04-01 20:03
grub-fstest
936.38
KB
-rwxr-xr-x
2026-04-01 20:03
grub-glue-efi
245.07
KB
-rwxr-xr-x
2026-04-01 20:03
grub-kbdcomp
1.64
KB
-rwxr-xr-x
2026-04-01 20:03
grub-menulst2cfg
229.12
KB
-rwxr-xr-x
2026-04-01 20:03
grub-mkfont
273.73
KB
-rwxr-xr-x
2026-04-01 20:03
grub-mkimage
354.26
KB
-rwxr-xr-x
2026-04-01 20:03
grub-mklayout
253.35
KB
-rwxr-xr-x
2026-04-01 20:03
grub-mknetdir
411.02
KB
-rwxr-xr-x
2026-04-01 20:03
grub-mkpasswd-pbkdf2
257.41
KB
-rwxr-xr-x
2026-04-01 20:03
grub-mkrelpath
244.76
KB
-rwxr-xr-x
2026-04-01 20:03
grub-mkrescue
993.12
KB
-rwxr-xr-x
2026-04-01 20:03
grub-mkstandalone
487.41
KB
-rwxr-xr-x
2026-04-01 20:03
grub-mount
759.3
KB
-rwxr-xr-x
2026-04-01 20:03
grub-render-label
827.26
KB
-rwxr-xr-x
2026-04-01 20:03
grub-script-check
272.88
KB
-rwxr-xr-x
2026-04-01 20:03
grub-syslinux2cfg
775.77
KB
-rwxr-xr-x
2026-04-01 20:03
gtbl
146.43
KB
-rwxr-xr-x
2023-03-07 09:38
gunzip
2.29
KB
-rwxr-xr-x
2022-04-10 02:22
gzexe
6.3
KB
-rwxr-xr-x
2022-04-10 02:22
gzip
95.84
KB
-rwxr-xr-x
2022-04-10 02:22
h2ph
28.54
KB
-rwxr-xr-x
2025-08-29 12:09
h2xs
59.51
KB
-rwxr-xr-x
2025-08-29 12:09
hardlink
50.39
KB
-rwxr-xr-x
2024-11-21 20:01
hd
58.32
KB
-rwxr-xr-x
2024-11-21 20:01
head
46.95
KB
-rwxr-xr-x
2022-09-20 15:27
helpztags
2.46
KB
-rwxr-xr-x
2025-02-16 05:23
hexdump
58.32
KB
-rwxr-xr-x
2024-11-21 20:01
hmm-assembler.pl
11.08
KB
-rwxr-xr-x
2013-11-30 07:54
hmm-info
118.62
KB
-rwxr-xr-x
2020-12-22 13:24
host
114.7
KB
-rwxr-xr-x
2026-07-31 21:11
hostid
38.83
KB
-rwxr-xr-x
2022-09-20 15:27
hostname
22.15
KB
-rwxr-xr-x
2022-12-19 13:33
hostnamectl
30.38
KB
-rwxr-xr-x
2026-04-27 19:48
htcacheclean
34.24
KB
-rwxr-xr-x
2026-06-12 05:08
htdbm
26.23
KB
-rwxr-xr-x
2026-06-12 05:08
htdigest
14.23
KB
-rwxr-xr-x
2026-06-12 05:08
html2text
214.17
KB
-rwxr-xr-x
2020-06-23 20:20
htpasswd
26.23
KB
-rwxr-xr-x
2026-06-12 05:08
i386
26.58
KB
-rwxr-xr-x
2024-11-21 20:01
iconv
63.13
KB
-rwxr-xr-x
2026-04-27 20:14
id
47.02
KB
-rwxr-xr-x
2022-09-20 15:27
infocmp
62.31
KB
-rwxr-xr-x
2023-05-07 14:33
infotocap
90.34
KB
-rwxr-xr-x
2023-05-07 14:33
innochecksum
4.51
MB
-rwxr-xr-x
2026-06-27 11:11
innotop
445.44
KB
-rwxr-xr-x
2026-06-27 11:11
install
155.8
KB
-rwxr-xr-x
2022-09-20 15:27
instmodsh
4.27
KB
-rwxr-xr-x
2025-08-29 12:09
ionice
34.31
KB
-rwxr-xr-x
2024-11-21 20:01
ip
674.82
KB
-rwxr-xr-x
2023-05-22 13:19
ipcmk
34.38
KB
-rwxr-xr-x
2024-11-21 20:01
ipcrm
34.31
KB
-rwxr-xr-x
2024-11-21 20:01
ipcs
74.31
KB
-rwxr-xr-x
2024-11-21 20:01
iptables-xml
88.98
KB
-rwxr-xr-x
2023-01-16 13:44
ischroot
14.32
KB
-rwxr-xr-x
2023-07-28 23:46
isodump
180.17
KB
-rwxr-xr-x
2022-06-24 14:56
isoinfo
343.42
KB
-rwxr-xr-x
2022-06-24 14:56
isovfy
184.14
KB
-rwxr-xr-x
2022-06-24 14:56
join
54.98
KB
-rwxr-xr-x
2022-09-20 15:27
journalctl
74.64
KB
-rwxr-xr-x
2026-04-27 19:48
json-patch-jsondiff
1004
B
-rwxr-xr-x
2021-09-29 10:31
json_pp
4.88
KB
-rwxr-xr-x
2025-08-29 12:09
json_xs
6.85
KB
-rwxr-xr-x
2025-09-08 20:30
jsondiff
1004
B
-rwxr-xr-x
2021-09-29 10:31
jsonpatch
3.77
KB
-rwxr-xr-x
2021-09-29 10:31
jsonpointer
1.79
KB
-rwxr-xr-x
2022-09-23 09:59
jsonschema
213
B
-rwxr-xr-x
2023-01-20 10:53
kbxutil
162.77
KB
-rwxr-xr-x
2026-01-01 14:54
kernel-install
12.75
KB
-rwxr-xr-x
2026-04-27 19:48
kill
22.3
KB
-rwxr-xr-x
2022-12-19 06:06
killall
31.95
KB
-rwxr-xr-x
2022-12-13 05:27
kmod
174.27
KB
-rwxr-xr-x
2022-12-10 00:02
last
50.31
KB
-rwxr-xr-x
2024-11-21 20:01
lastb
50.31
KB
-rwxr-xr-x
2024-11-21 20:01
lastlog
31.75
KB
-rwxr-xr-x
2025-12-14 14:00
lcf
7.6
KB
-rwxr-xr-x
2024-12-20 07:39
ld.so
209.96
KB
-rwxr-xr-x
2026-04-27 20:14
ldd
5.28
KB
-rwxr-xr-x
2026-04-27 20:14
less
194.3
KB
-rwxr-xr-x
2024-05-02 18:30
lessecho
14.24
KB
-rwxr-xr-x
2024-05-02 18:30
lessfile
8.83
KB
-rwxr-xr-x
2024-05-02 18:30
lesskey
23.63
KB
-rwxr-xr-x
2024-05-02 18:30
lesspipe
8.83
KB
-rwxr-xr-x
2024-05-02 18:30
lexgrog
107.48
KB
-rwxr-xr-x
2023-03-12 22:23
lft
2.43
KB
-rwxr-xr-x
2023-02-25 12:24
lft.db
2.43
KB
-rwxr-xr-x
2023-02-25 12:24
libnetcfg
15.41
KB
-rwxr-xr-x
2025-08-29 12:09
link
38.83
KB
-rwxr-xr-x
2022-09-20 15:27
linux-check-removal
4.6
KB
-rwxr-xr-x
2025-05-25 15:54
linux-run-hooks
3.46
KB
-rwxr-xr-x
2026-06-08 20:53
linux-update-symlinks
6.38
KB
-rwxr-xr-x
2025-05-25 15:54
linux-version
2.67
KB
-rwxr-xr-x
2025-05-25 15:54
linux32
26.58
KB
-rwxr-xr-x
2024-11-21 20:01
linux64
26.58
KB
-rwxr-xr-x
2024-11-21 20:01
ln
71.12
KB
-rwxr-xr-x
2022-09-20 15:27
lnstat
26.59
KB
-rwxr-xr-x
2023-05-22 13:19
locale
46.16
KB
-rwxr-xr-x
2026-04-27 20:14
localectl
26.38
KB
-rwxr-xr-x
2026-04-27 19:48
localedef
291.91
KB
-rwxr-xr-x
2026-04-27 20:14
logger
54.9
KB
-rwxr-xr-x
2024-11-21 20:01
login
51.78
KB
-rwxr-xr-x
2025-12-14 14:00
loginctl
58.48
KB
-rwxr-xr-x
2026-04-27 19:48
logname
38.83
KB
-rwxr-xr-x
2022-09-20 15:27
logresolve
14.24
KB
-rwxr-xr-x
2026-06-12 05:08
look
18.31
KB
-rwxr-xr-x
2024-11-21 20:01
ls
147.8
KB
-rwxr-xr-x
2022-09-20 15:27
lsattr
14.24
KB
-rwxr-xr-x
2025-06-06 17:12
lsb_release
2.59
KB
-rwxr-xr-x
2022-09-26 20:06
lsblk
202.31
KB
-rwxr-xr-x
2024-11-21 20:01
lscpu
126.31
KB
-rwxr-xr-x
2024-11-21 20:01
lsfd
120.3
KB
-rwxr-xr-x
2024-11-21 20:01
lsinitramfs
735
B
-rwxr-xr-x
2025-03-02 16:09
lsipc
98.31
KB
-rwxr-xr-x
2024-11-21 20:01
lsirq
34.48
KB
-rwxr-xr-x
2024-11-21 20:01
lslocks
70.7
KB
-rwxr-xr-x
2024-11-21 20:01
lslogins
94.31
KB
-rwxr-xr-x
2024-11-21 20:01
lsmem
66.31
KB
-rwxr-xr-x
2024-11-21 20:01
lsmod
174.27
KB
-rwxr-xr-x
2022-12-10 00:02
lsns
82.31
KB
-rwxr-xr-x
2024-11-21 20:01
lsof
175.61
KB
-rwxr-xr-x
2022-04-28 04:08
lspci
104.04
KB
-rwxr-xr-x
2023-01-17 23:50
lspgpot
1.06
KB
-rwxr-xr-x
2017-08-28 10:22
lynx
1.86
MB
-rwxr-xr-x
2023-01-15 14:21
lzcat
82.7
KB
-rwxr-xr-x
2026-06-26 13:13
lzcmp
7.25
KB
-rwxr-xr-x
2026-06-26 13:13
lzdiff
7.25
KB
-rwxr-xr-x
2026-06-26 13:13
lzegrep
10.09
KB
-rwxr-xr-x
2026-06-26 13:13
lzfgrep
10.09
KB
-rwxr-xr-x
2026-06-26 13:13
lzgrep
10.09
KB
-rwxr-xr-x
2026-06-26 13:13
lzless
1.77
KB
-rwxr-xr-x
2026-06-26 13:13
lzma
82.7
KB
-rwxr-xr-x
2026-06-26 13:13
lzmainfo
14.3
KB
-rwxr-xr-x
2026-06-26 13:13
lzmore
2.14
KB
-rwxr-xr-x
2026-06-26 13:13
mail
225.28
KB
-rwxr-xr-x
2023-03-03 16:00
mail.mailutils
225.28
KB
-rwxr-xr-x
2023-03-03 16:00
mailq
30.38
KB
-rwxr-xr-x
2024-03-06 15:10
mailx
225.28
KB
-rwxr-xr-x
2023-03-03 16:00
man
121.36
KB
-rwxr-xr-x
2023-03-12 22:23
man-recode
35.38
KB
-rwxr-xr-x
2023-03-12 22:23
mandb
147.61
KB
-rwxr-xr-x
2023-03-12 22:23
manpath
34.78
KB
-rwxr-xr-x
2023-03-12 22:23
mariadb
4.98
MB
-rwxr-xr-x
2026-06-27 11:11
mariadb-access
109.31
KB
-rwxr-xr-x
2026-06-27 11:11
mariadb-admin
4.76
MB
-rwxr-xr-x
2026-06-27 11:11
mariadb-analyze
4.76
MB
-rwxr-xr-x
2026-06-27 11:11
mariadb-binlog
5.02
MB
-rwxr-xr-x
2026-06-27 11:11
mariadb-check
4.76
MB
-rwxr-xr-x
2026-06-27 11:11
mariadb-conv
4.5
MB
-rwxr-xr-x
2026-06-27 11:11
mariadb-convert-table-format
4.12
KB
-rwxr-xr-x
2026-06-27 11:11
mariadb-dump
4.85
MB
-rwxr-xr-x
2026-06-27 11:11
mariadb-dumpslow
8.05
KB
-rwxr-xr-x
2026-06-27 11:11
mariadb-find-rows
3.21
KB
-rwxr-xr-x
2026-06-27 11:11
mariadb-fix-extensions
1.22
KB
-rwxr-xr-x
2026-06-27 11:11
mariadb-hotcopy
34.53
KB
-rwxr-xr-x
2026-06-27 11:11
mariadb-import
4.75
MB
-rwxr-xr-x
2026-06-27 11:11
mariadb-install-db
22.13
KB
-rwxr-xr-x
2026-06-27 11:11
mariadb-optimize
4.76
MB
-rwxr-xr-x
2026-06-27 11:11
mariadb-plugin
4.48
MB
-rwxr-xr-x
2026-06-27 11:11
mariadb-repair
4.76
MB
-rwxr-xr-x
2026-06-27 11:11
mariadb-report
49.02
KB
-rwxr-xr-x
2025-02-10 17:26
mariadb-secure-installation
13.48
KB
-rwxr-xr-x
2026-06-27 11:11
mariadb-service-convert
2.45
KB
-rwxr-xr-x
2026-06-27 11:11
mariadb-setpermission
17.56
KB
-rwxr-xr-x
2026-06-27 11:11
mariadb-show
4.75
MB
-rwxr-xr-x
2026-06-27 11:11
mariadb-slap
4.77
MB
-rwxr-xr-x
2026-06-27 11:11
mariadb-tzinfo-to-sql
4.48
MB
-rwxr-xr-x
2026-06-27 11:11
mariadb-upgrade
4.91
MB
-rwxr-xr-x
2026-06-27 11:11
mariadb-waitpid
4.46
MB
-rwxr-xr-x
2026-06-27 11:11
mariadbcheck
4.76
MB
-rwxr-xr-x
2026-06-27 11:11
mariadbd-multi
26.69
KB
-rwxr-xr-x
2026-06-27 11:11
mariadbd-safe
30.42
KB
-rwxr-xr-x
2026-06-27 11:11
mariadbd-safe-helper
4.44
MB
-rwxr-xr-x
2026-06-27 11:11
markdown-it
220
B
-rwxr-xr-x
2023-03-31 10:50
mawk
154.66
KB
-rwxr-xr-x
2022-06-17 15:35
mc
1.02
MB
-rwxr-xr-x
2023-02-14 12:56
mcdiff
1.02
MB
-rwxr-xr-x
2023-02-14 12:56
mcedit
1.02
MB
-rwxr-xr-x
2023-02-14 12:56
mcookie
34.38
KB
-rwxr-xr-x
2024-11-21 20:01
mcview
1.02
MB
-rwxr-xr-x
2023-02-14 12:56
md5sum
50.95
KB
-rwxr-xr-x
2022-09-20 15:27
md5sum.textutils
50.95
KB
-rwxr-xr-x
2022-09-20 15:27
mesg
18.3
KB
-rwxr-xr-x
2024-11-21 20:01
messages
14.6
KB
-rwxr-xr-x
2023-03-03 16:00
messages.mailutils
14.6
KB
-rwxr-xr-x
2023-03-03 16:00
migrate-pubring-from-classic-gpg
2.99
KB
-rwxr-xr-x
2025-12-31 17:32
mimeview
19.28
KB
-rwxr-xr-x
2023-03-03 16:00
mkdir
95.27
KB
-rwxr-xr-x
2022-09-20 15:27
mkfifo
67.17
KB
-rwxr-xr-x
2022-09-20 15:27
mkisofs
631.17
KB
-rwxr-xr-x
2022-06-24 14:56
mknod
71.2
KB
-rwxr-xr-x
2022-09-20 15:27
mksquashfs
263.9
KB
-rwxr-xr-x
2022-03-27 16:50
mktemp
42.92
KB
-rwxr-xr-x
2022-09-20 15:27
mkzftree
30.84
KB
-rwxr-xr-x
2022-06-24 14:56
mokutil
60.27
KB
-rwxr-xr-x
2022-06-15 13:30
more
58.31
KB
-rwxr-xr-x
2024-11-21 20:01
mount
58.3
KB
-rwsr-xr-x
2024-11-21 20:01
mount-image-callback
13.86
KB
-rwxr-xr-x
2022-06-03 10:51
mountpoint
18.3
KB
-rwxr-xr-x
2024-11-21 20:01
movemail
40.19
KB
-rwxr-xr-x
2023-03-03 16:00
movemail.mailutils
40.19
KB
-rwxr-xr-x
2023-03-03 16:00
msql2mysql
1.41
KB
-rwxr-xr-x
2026-06-27 11:11
mt
83.38
KB
-rwxr-xr-x
2022-09-14 19:45
mt-gnu
83.38
KB
-rwxr-xr-x
2022-09-14 19:45
mv
139.62
KB
-rwxr-xr-x
2022-09-20 15:27
my_print_defaults
4.47
MB
-rwxr-xr-x
2026-06-27 11:11
myisam_ftdump
4.75
MB
-rwxr-xr-x
2026-06-27 11:11
myisamchk
4.87
MB
-rwxr-xr-x
2026-06-27 11:11
myisamlog
4.73
MB
-rwxr-xr-x
2026-06-27 11:11
myisampack
4.77
MB
-rwxr-xr-x
2026-06-27 11:11
mysql
4.98
MB
-rwxr-xr-x
2026-06-27 11:11
mysql_convert_table_format
4.12
KB
-rwxr-xr-x
2026-06-27 11:11
mysql_find_rows
3.21
KB
-rwxr-xr-x
2026-06-27 11:11
mysql_fix_extensions
1.22
KB
-rwxr-xr-x
2026-06-27 11:11
mysql_install_db
22.13
KB
-rwxr-xr-x
2026-06-27 11:11
mysql_plugin
4.48
MB
-rwxr-xr-x
2026-06-27 11:11
mysql_secure_installation
13.48
KB
-rwxr-xr-x
2026-06-27 11:11
mysql_setpermission
17.56
KB
-rwxr-xr-x
2026-06-27 11:11
mysql_tzinfo_to_sql
4.48
MB
-rwxr-xr-x
2026-06-27 11:11
mysql_upgrade
4.91
MB
-rwxr-xr-x
2026-06-27 11:11
mysql_waitpid
4.46
MB
-rwxr-xr-x
2026-06-27 11:11
mysqlaccess
109.31
KB
-rwxr-xr-x
2026-06-27 11:11
mysqladmin
4.76
MB
-rwxr-xr-x
2026-06-27 11:11
mysqlanalyze
4.76
MB
-rwxr-xr-x
2026-06-27 11:11
mysqlbinlog
5.02
MB
-rwxr-xr-x
2026-06-27 11:11
mysqlcheck
4.76
MB
-rwxr-xr-x
2026-06-27 11:11
mysqld_multi
26.69
KB
-rwxr-xr-x
2026-06-27 11:11
mysqld_safe
30.42
KB
-rwxr-xr-x
2026-06-27 11:11
mysqld_safe_helper
4.44
MB
-rwxr-xr-x
2026-06-27 11:11
mysqldump
4.85
MB
-rwxr-xr-x
2026-06-27 11:11
mysqldumpslow
8.05
KB
-rwxr-xr-x
2026-06-27 11:11
mysqlhotcopy
34.53
KB
-rwxr-xr-x
2026-06-27 11:11
mysqlimport
4.75
MB
-rwxr-xr-x
2026-06-27 11:11
mysqloptimize
4.76
MB
-rwxr-xr-x
2026-06-27 11:11
mysqlrepair
4.76
MB
-rwxr-xr-x
2026-06-27 11:11
mysqlreport
49.02
KB
-rwxr-xr-x
2025-02-10 17:26
mysqlshow
4.75
MB
-rwxr-xr-x
2026-06-27 11:11
mysqlslap
4.77
MB
-rwxr-xr-x
2026-06-27 11:11
mytop
72.03
KB
-rwxr-xr-x
2026-06-27 11:11
namei
34.31
KB
-rwxr-xr-x
2024-11-21 20:01
nano
280.74
KB
-rwxr-xr-x
2024-05-06 06:10
nawk
696.44
KB
-rwxr-xr-x
2023-02-19 13:30
neqn
913
B
-rwxr-xr-x
2023-03-07 09:38
netstat
151.66
KB
-rwxr-xr-x
2025-05-26 19:27
networkctl
106.38
KB
-rwxr-xr-x
2026-04-27 19:48
newaliases
30.38
KB
-rwxr-xr-x
2024-03-06 15:10
newgrp
47.75
KB
-rwsr-xr-x
2025-12-14 14:00
ngettext
34.31
KB
-rwxr-xr-x
2023-02-26 15:20
nice
42.86
KB
-rwxr-xr-x
2022-09-20 15:27
nisdomainname
22.15
KB
-rwxr-xr-x
2022-12-19 13:33
nl
111.11
KB
-rwxr-xr-x
2022-09-20 15:27
nohup
42.89
KB
-rwxr-xr-x
2022-09-20 15:27
normalizer
244
B
-rwxr-xr-x
2022-11-27 08:00
nproc
42.89
KB
-rwxr-xr-x
2022-09-20 15:27
nroff
3.22
KB
-rwxr-xr-x
2023-03-07 09:38
nsenter
34.54
KB
-rwxr-xr-x
2024-11-21 20:01
nstat
104.45
KB
-rwxr-xr-x
2023-05-22 13:19
numfmt
67.02
KB
-rwxr-xr-x
2022-09-20 15:27
od
79.02
KB
-rwxr-xr-x
2022-09-20 15:27
open
18.06
KB
-rwxr-xr-x
2021-11-29 13:07
openssl
953.26
KB
-rwxr-xr-x
2026-06-06 19:56
pager
194.3
KB
-rwxr-xr-x
2024-05-02 18:30
partx
118.31
KB
-rwxr-xr-x
2024-11-21 20:01
passwd
66.65
KB
-rwsr-xr-x
2025-12-14 14:00
paste
42.89
KB
-rwxr-xr-x
2022-09-20 15:27
patch-hmm.pl
580
B
-rwxr-xr-x
2013-11-30 07:54
pathchk
42.86
KB
-rwxr-xr-x
2022-09-20 15:27
pdb3
62.4
KB
-rwxr-xr-x
2026-05-12 05:17
pdb3.11
62.4
KB
-rwxr-xr-x
2026-05-12 05:17
peekfd
14.5
KB
-rwxr-xr-x
2022-12-13 05:27
perl
3.63
MB
-rwxr-xr-x
2025-08-29 12:09
perl5.36-x86_64-linux-gnu
14.41
KB
-rwxr-xr-x
2025-08-29 12:09
perl5.36.0
3.63
MB
-rwxr-xr-x
2025-08-29 12:09
perlbug
44.12
KB
-rwxr-xr-x
2025-08-29 12:09
perldoc
125
B
-rwxr-xr-x
2025-08-16 18:03
perlivp
10.61
KB
-rwxr-xr-x
2025-08-29 12:09
perlthanks
44.12
KB
-rwxr-xr-x
2025-08-29 12:09
perror
4.66
MB
-rwxr-xr-x
2026-06-27 11:11
pgrep
34.42
KB
-rwxr-xr-x
2022-12-19 06:06
phar
14.88
KB
-rwxr-xr-x
2026-07-03 10:04
phar.default
14.88
KB
-rwxr-xr-x
2026-07-03 10:04
phar.phar
14.88
KB
-rwxr-xr-x
2026-07-03 10:04
phar.phar.default
14.88
KB
-rwxr-xr-x
2026-07-03 10:04
phar.phar8.1
14.89
KB
-rwxr-xr-x
2026-07-03 10:33
phar.phar8.3
14.88
KB
-rwxr-xr-x
2026-07-08 19:13
phar.phar8.4
14.88
KB
-rwxr-xr-x
2026-07-03 10:04
phar8.1
14.89
KB
-rwxr-xr-x
2026-07-03 10:33
phar8.1.phar
14.89
KB
-rwxr-xr-x
2026-07-03 10:33
phar8.3
14.88
KB
-rwxr-xr-x
2026-07-08 19:13
phar8.3.phar
14.88
KB
-rwxr-xr-x
2026-07-08 19:13
phar8.4
14.88
KB
-rwxr-xr-x
2026-07-03 10:04
phar8.4.phar
14.88
KB
-rwxr-xr-x
2026-07-03 10:04
php
5.3
MB
-rwxr-xr-x
2026-07-03 10:33
php.default
5.73
MB
-rwxr-xr-x
2026-07-03 10:04
php8.1
5.3
MB
-rwxr-xr-x
2026-07-03 10:33
php8.3
5.5
MB
-rwxr-xr-x
2026-07-08 19:13
php8.4
5.73
MB
-rwxr-xr-x
2026-07-03 10:04
pic
220.27
KB
-rwxr-xr-x
2023-03-07 09:38
pico
280.74
KB
-rwxr-xr-x
2024-05-06 06:10
piconv
8.16
KB
-rwxr-xr-x
2025-08-29 12:09
pidof
26.31
KB
-rwxr-xr-x
2023-04-03 06:25
pidwait
34.42
KB
-rwxr-xr-x
2022-12-19 06:06
pinentry
70.57
KB
-rwxr-xr-x
2022-10-18 14:52
pinentry-curses
70.57
KB
-rwxr-xr-x
2022-10-18 14:52
ping
88.45
KB
-rwxr-xr-x
2024-09-24 17:00
ping4
88.45
KB
-rwxr-xr-x
2024-09-24 17:00
ping6
88.45
KB
-rwxr-xr-x
2024-09-24 17:00
pinky
47.05
KB
-rwxr-xr-x
2022-09-20 15:27
pkaction
18.23
KB
-rwxr-xr-x
2023-01-31 22:05
pkcheck
22.3
KB
-rwxr-xr-x
2023-01-31 22:05
pkill
34.42
KB
-rwxr-xr-x
2022-12-19 06:06
pkttyagent
18.23
KB
-rwxr-xr-x
2023-01-31 22:05
pl2pm
4.43
KB
-rwxr-xr-x
2025-08-29 12:09
pldd
22.69
KB
-rwxr-xr-x
2026-04-27 20:14
pmap
34.34
KB
-rwxr-xr-x
2022-12-19 06:06
pod2html
4.04
KB
-rwxr-xr-x
2025-08-29 12:09
pod2man
14.68
KB
-rwxr-xr-x
2025-08-29 12:09
pod2text
10.55
KB
-rwxr-xr-x
2025-08-29 12:09
pod2usage
4.01
KB
-rwxr-xr-x
2025-08-29 12:09
podchecker
3.57
KB
-rwxr-xr-x
2025-08-29 12:09
pr
79.11
KB
-rwxr-xr-x
2022-09-20 15:27
preconv
66.43
KB
-rwxr-xr-x
2023-03-07 09:38
print
18.06
KB
-rwxr-xr-x
2021-11-29 13:07
printenv
34.83
KB
-rwxr-xr-x
2022-09-20 15:27
printf
62.92
KB
-rwxr-xr-x
2022-09-20 15:27
prlimit
38.83
KB
-rwxr-xr-x
2024-11-21 20:01
procan
79.91
KB
-rwxr-xr-x
2022-11-06 08:15
prove
13.34
KB
-rwxr-xr-x
2025-08-29 12:09
prtstat
18.57
KB
-rwxr-xr-x
2022-12-13 05:27
ps
142.93
KB
-rwxr-xr-x
2022-12-19 06:06
pslog
14.45
KB
-rwxr-xr-x
2022-12-13 05:27
pstree
35.78
KB
-rwxr-xr-x
2022-12-13 05:27
pstree.x11
35.78
KB
-rwxr-xr-x
2022-12-13 05:27
ptar
3.48
KB
-rwxr-xr-x
2025-08-29 12:09
ptardiff
2.58
KB
-rwxr-xr-x
2025-08-29 12:09
ptargrep
4.29
KB
-rwxr-xr-x
2025-08-29 12:09
ptx
135.23
KB
-rwxr-xr-x
2022-09-20 15:27
pv
63.98
KB
-rwxr-xr-x
2022-04-12 00:55
pwd
42.92
KB
-rwxr-xr-x
2022-09-20 15:27
pwdx
14.3
KB
-rwxr-xr-x
2022-12-19 06:06
py3clean
7.63
KB
-rwxr-xr-x
2023-04-09 10:22
py3compile
13
KB
-rwxr-xr-x
2023-04-09 10:22
py3versions
12.52
KB
-rwxr-xr-x
2023-04-09 10:22
pydoc3
79
B
-rwxr-xr-x
2026-05-12 05:17
pydoc3.11
79
B
-rwxr-xr-x
2026-05-12 05:17
pygettext3
23.67
KB
-rwxr-xr-x
2023-02-07 13:37
pygettext3.11
23.67
KB
-rwxr-xr-x
2023-02-07 13:37
pygmentize
970
B
-rwxr-xr-x
2023-01-07 09:12
pyserial-miniterm
975
B
-rwxr-xr-x
2022-09-26 15:04
pyserial-ports
969
B
-rwxr-xr-x
2022-09-26 15:04
python3
6.52
MB
-rwxr-xr-x
2026-05-12 05:17
python3.11
6.52
MB
-rwxr-xr-x
2026-05-12 05:17
pzstd
742.38
KB
-rwxr-xr-x
2023-03-18 20:58
qemu-img
2.19
MB
-rwxr-xr-x
2026-05-25 20:44
qemu-io
2.14
MB
-rwxr-xr-x
2026-05-25 20:44
qemu-nbd
2.33
MB
-rwxr-xr-x
2026-05-25 20:44
qrencode
38.56
KB
-rwxr-xr-x
2020-12-22 05:31
querybts
10.64
KB
-rwxr-xr-x
2023-04-29 06:38
rbash
1.21
MB
-rwxr-xr-x
2026-05-07 20:33
rdma
180.6
KB
-rwxr-xr-x
2023-05-22 13:19
readlink
50.89
KB
-rwxr-xr-x
2022-09-20 15:27
readmsg
35.84
KB
-rwxr-xr-x
2023-03-03 16:00
readmsg.mailutils
35.84
KB
-rwxr-xr-x
2023-03-03 16:00
realpath
50.92
KB
-rwxr-xr-x
2022-09-20 15:27
rename.ul
22.3
KB
-rwxr-xr-x
2024-11-21 20:01
renice
14.3
KB
-rwxr-xr-x
2024-11-21 20:01
replace
4.45
MB
-rwxr-xr-x
2026-06-27 11:11
reportbug
110.11
KB
-rwxr-xr-x
2023-04-29 06:38
reset
30.24
KB
-rwxr-xr-x
2023-05-07 14:33
resize-part-image
4.23
KB
-rwxr-xr-x
2022-06-03 10:51
resizepart
70.31
KB
-rwxr-xr-x
2024-11-21 20:01
resolve_stack_dump
4.47
MB
-rwxr-xr-x
2026-06-27 11:11
resolvectl
146.53
KB
-rwxr-xr-x
2026-04-27 19:48
resolveip
4.46
MB
-rwxr-xr-x
2026-06-27 11:11
rev
14.3
KB
-rwxr-xr-x
2024-11-21 20:01
rgrep
30
B
-rwxr-xr-x
2020-01-29 12:09
rm
71.05
KB
-rwxr-xr-x
2022-09-20 15:27
rmail
18.3
KB
-rwxr-xr-x
2024-03-06 15:10
rmdir
54.92
KB
-rwxr-xr-x
2022-09-20 15:27
rnano
280.74
KB
-rwxr-xr-x
2024-05-06 06:10
rotatelogs
26.31
KB
-rwxr-xr-x
2026-06-12 05:08
routel
1.62
KB
-rwxr-xr-x
2023-05-22 13:19
rrsync
12.34
KB
-rwxr-xr-x
2026-05-24 21:23
rsync
514.35
KB
-rwxr-xr-x
2026-05-24 21:23
rsync-ssl
5.02
KB
-rwxr-xr-x
2026-05-24 21:23
rtstat
26.59
KB
-rwxr-xr-x
2023-05-22 13:19
run-mailcap
18.06
KB
-rwxr-xr-x
2021-11-29 13:07
run-parts
26.91
KB
-rwxr-xr-x
2023-07-28 23:46
runcon
42.95
KB
-rwxr-xr-x
2022-09-20 15:27
rview
3.48
MB
-rwxr-xr-x
2025-02-16 05:23
rvim
3.48
MB
-rwxr-xr-x
2025-02-16 05:23
savelog
10.24
KB
-rwxr-xr-x
2023-07-28 23:46
scp
266.63
KB
-rwxr-xr-x
2026-05-05 10:26
screen
471.09
KB
-rwxr-xr-x
2023-01-09 03:56
script
70.3
KB
-rwxr-xr-x
2024-11-21 20:01
scriptlive
54.3
KB
-rwxr-xr-x
2024-11-21 20:01
scriptreplay
46.3
KB
-rwxr-xr-x
2024-11-21 20:01
sdiff
55.08
KB
-rwxr-xr-x
2023-02-03 19:00
sed
123.46
KB
-rwxr-xr-x
2026-04-21 07:50
see
18.06
KB
-rwxr-xr-x
2021-11-29 13:07
select-editor
2.39
KB
-rwxr-xr-x
2023-01-14 16:28
sensible-browser
1.26
KB
-rwxr-xr-x
2023-01-14 16:28
sensible-editor
1.24
KB
-rwxr-xr-x
2023-01-14 16:28
sensible-pager
565
B
-rwxr-xr-x
2023-01-14 16:28
seq
58.92
KB
-rwxr-xr-x
2022-09-20 15:27
setarch
26.58
KB
-rwxr-xr-x
2024-11-21 20:01
setpci
30.31
KB
-rwxr-xr-x
2023-01-17 23:50
setpriv
78.31
KB
-rwxr-xr-x
2024-11-21 20:01
setsid
14.3
KB
-rwxr-xr-x
2024-11-21 20:01
setterm
46.31
KB
-rwxr-xr-x
2024-11-21 20:01
sftp
282.59
KB
-rwxr-xr-x
2026-05-05 10:26
sg
47.75
KB
-rwsr-xr-x
2025-12-14 14:00
sh
122.7
KB
-rwxr-xr-x
2023-01-05 13:20
sha1sum
54.95
KB
-rwxr-xr-x
2022-09-20 15:27
sha224sum
58.95
KB
-rwxr-xr-x
2022-09-20 15:27
sha256sum
58.95
KB
-rwxr-xr-x
2022-09-20 15:27
sha384sum
62.95
KB
-rwxr-xr-x
2022-09-20 15:27
sha512sum
62.95
KB
-rwxr-xr-x
2022-09-20 15:27
shasum
9.75
KB
-rwxr-xr-x
2025-08-29 12:09
shred
63.14
KB
-rwxr-xr-x
2022-09-20 15:27
shuf
58.98
KB
-rwxr-xr-x
2022-09-20 15:27
sieve
31.98
KB
-rwxr-xr-x
2023-03-03 16:00
skill
30.33
KB
-rwxr-xr-x
2022-12-19 06:06
slabtop
22.37
KB
-rwxr-xr-x
2022-12-19 06:06
sleep
42.86
KB
-rwxr-xr-x
2022-09-20 15:27
slogin
1.08
MB
-rwxr-xr-x
2026-05-05 10:26
snap
14.79
MB
-rwxr-xr-x
2026-05-10 10:28
snap-hmm
56
B
-rwxr-xr-x
2020-08-18 08:47
snapctl
5.81
MB
-rwxr-xr-x
2026-05-10 10:28
snice
30.33
KB
-rwxr-xr-x
2022-12-19 06:06
socat
401.98
KB
-rwxr-xr-x
2022-11-06 08:15
soelim
50.43
KB
-rwxr-xr-x
2023-03-07 09:38
sort
115.68
KB
-rwxr-xr-x
2022-09-20 15:27
splain
18.99
KB
-rwxr-xr-x
2025-08-29 12:09
split
59.55
KB
-rwxr-xr-x
2022-09-20 15:27
sqfscat
141.37
KB
-rwxr-xr-x
2022-03-27 16:50
sqfstar
263.9
KB
-rwxr-xr-x
2022-03-27 16:50
ss
189.14
KB
-rwxr-xr-x
2023-05-22 13:19
ssh
1.08
MB
-rwxr-xr-x
2026-05-05 10:26
ssh-add
518.44
KB
-rwxr-xr-x
2026-05-05 10:26
ssh-agent
474.38
KB
-rwxr-sr-x
2026-05-05 10:26
ssh-argv0
1.42
KB
-rwxr-xr-x
2026-05-05 10:26
ssh-copy-id
12.38
KB
-rwxr-xr-x
2023-02-02 12:21
ssh-import-id
409
B
-rwxr-xr-x
2020-03-08 23:48
ssh-import-id-gh
785
B
-rwxr-xr-x
2020-02-28 15:44
ssh-import-id-lp
785
B
-rwxr-xr-x
2020-02-28 15:44
ssh-keygen
646.44
KB
-rwxr-xr-x
2026-05-05 10:26
ssh-keyscan
622.47
KB
-rwxr-xr-x
2026-05-05 10:26
stat
95.2
KB
-rwxr-xr-x
2022-09-20 15:27
stdbuf
58.92
KB
-rwxr-xr-x
2022-09-20 15:27
streamzip
7.75
KB
-rwxr-xr-x
2025-08-29 12:09
stty
83.02
KB
-rwxr-xr-x
2022-09-20 15:27
su
70.31
KB
-rwsr-xr-x
2024-11-21 20:01
sudo
275.02
KB
-rwsr-xr-x
2026-04-11 12:01
sudoedit
275.02
KB
-rwsr-xr-x
2026-04-11 12:01
sudoreplay
115.7
KB
-rwxr-xr-x
2026-04-11 12:01
sum
50.96
KB
-rwxr-xr-x
2022-09-20 15:27
sync
38.89
KB
-rwxr-xr-x
2022-09-20 15:27
systemctl
1.29
MB
-rwxr-xr-x
2026-04-27 19:48
systemd
90.38
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-analyze
182.61
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-ask-password
18.48
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-cat
18.38
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-cgls
22.48
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-cgtop
38.4
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-creds
42.61
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-cryptenroll
58.6
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-delta
26.38
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-detect-virt
18.37
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-escape
18.37
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-firstboot
50.59
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-hwdb
126.66
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-id128
22.37
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-inhibit
22.39
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-machine-id-setup
18.48
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-mount
50.59
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-notify
18.38
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-path
18.37
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-repart
150.69
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-run
58.57
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-socket-activate
26.38
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-stdio-bridge
18.38
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-sysext
42.49
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-sysusers
62.68
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-tmpfiles
110.57
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-tty-ask-password-agent
34.38
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-umount
50.59
KB
-rwxr-xr-x
2026-04-27 19:48
tabs
18.23
KB
-rwxr-xr-x
2023-05-07 14:33
tac
111.05
KB
-rwxr-xr-x
2022-09-20 15:27
tail
75.14
KB
-rwxr-xr-x
2022-09-20 15:27
tar
519.52
KB
-rwxr-xr-x
2024-01-20 09:27
taskset
62.31
KB
-rwxr-xr-x
2024-11-21 20:01
tbl
146.43
KB
-rwxr-xr-x
2023-03-07 09:38
tcpdump
1.21
MB
-rwxr-xr-x
2023-01-14 17:23
tee
42.95
KB
-rwxr-xr-x
2022-09-20 15:27
tempfile
14.18
KB
-rwxr-xr-x
2023-07-28 23:46
test
58.89
KB
-rwxr-xr-x
2022-09-20 15:27
tic
90.34
KB
-rwxr-xr-x
2023-05-07 14:33
timedatectl
42.37
KB
-rwxr-xr-x
2026-04-27 19:48
timeout
47.49
KB
-rwxr-xr-x
2022-09-20 15:27
tload
18.32
KB
-rwxr-xr-x
2022-12-19 06:06
toe
22.23
KB
-rwxr-xr-x
2023-05-07 14:33
top
131.58
KB
-rwxr-xr-x
2022-12-19 06:06
touch
107.05
KB
-rwxr-xr-x
2022-09-20 15:27
tput
26.27
KB
-rwxr-xr-x
2023-05-07 14:33
tr
54.89
KB
-rwxr-xr-x
2022-09-20 15:27
traceproto
2.82
KB
-rwxr-xr-x
2023-02-25 12:24
traceproto.db
2.82
KB
-rwxr-xr-x
2023-02-25 12:24
traceroute
71.23
KB
-rwxr-xr-x
2023-02-25 12:24
traceroute-nanog
1.58
KB
-rwxr-xr-x
2023-02-25 12:24
traceroute.db
71.23
KB
-rwxr-xr-x
2023-02-25 12:24
traceroute6
71.23
KB
-rwxr-xr-x
2023-02-25 12:24
traceroute6.db
71.23
KB
-rwxr-xr-x
2023-02-25 12:24
troff
755.83
KB
-rwxr-xr-x
2023-03-07 09:38
true
34.83
KB
-rwxr-xr-x
2022-09-20 15:27
truncate
42.89
KB
-rwxr-xr-x
2022-09-20 15:27
tset
30.24
KB
-rwxr-xr-x
2023-05-07 14:33
tsort
54.89
KB
-rwxr-xr-x
2022-09-20 15:27
tty
34.86
KB
-rwxr-xr-x
2022-09-20 15:27
tzselect
14.99
KB
-rwxr-xr-x
2026-04-27 20:14
ubuntu-cloudimg-query
8.37
KB
-rwxr-xr-x
2022-06-03 10:51
ubuntu-core-launcher
112.1
KB
-rwsr-xr-x
2026-05-10 10:28
ucf
40.69
KB
-rwxr-xr-x
2024-12-20 07:39
ucfq
18.91
KB
-rwxr-xr-x
2024-12-20 07:39
ucfr
10.85
KB
-rwxr-xr-x
2024-12-20 07:39
uclampset
62.31
KB
-rwxr-xr-x
2024-11-21 20:01
udevadm
1.29
MB
-rwxr-xr-x
2026-04-27 19:48
ul
22.31
KB
-rwxr-xr-x
2024-11-21 20:01
umount
34.3
KB
-rwsr-xr-x
2024-11-21 20:01
uname
42.86
KB
-rwxr-xr-x
2022-09-20 15:27
unattended-upgrade
97.21
KB
-rwxr-xr-x
2022-12-31 20:59
unattended-upgrades
97.21
KB
-rwxr-xr-x
2022-12-31 20:59
uncompress
2.29
KB
-rwxr-xr-x
2022-04-10 02:22
unexpand
42.92
KB
-rwxr-xr-x
2022-09-20 15:27
uniq
46.95
KB
-rwxr-xr-x
2022-09-20 15:27
unlink
38.83
KB
-rwxr-xr-x
2022-09-20 15:27
unlzma
82.7
KB
-rwxr-xr-x
2026-06-26 13:13
unmkinitramfs
3.59
KB
-rwxr-xr-x
2025-04-24 15:40
unshare
82.54
KB
-rwxr-xr-x
2024-11-21 20:01
unsquashfs
141.37
KB
-rwxr-xr-x
2022-03-27 16:50
unxz
82.7
KB
-rwxr-xr-x
2026-06-26 13:13
unzip
175.05
KB
-rwxr-xr-x
2026-08-16 13:50
unzipsfx
82.86
KB
-rwxr-xr-x
2026-08-16 13:50
unzstd
1.22
MB
-rwxr-xr-x
2023-03-18 20:58
update-alternatives
58.31
KB
-rwxr-xr-x
2026-03-07 12:15
update-mime-database
59.27
KB
-rwxr-xr-x
2022-04-29 17:19
uptime
14.3
KB
-rwxr-xr-x
2022-12-19 06:06
users
38.89
KB
-rwxr-xr-x
2022-09-20 15:27
utmpdump
30.3
KB
-rwxr-xr-x
2024-11-21 20:01
uuidgen
18.3
KB
-rwxr-xr-x
2024-11-21 20:01
uuidparse
42.31
KB
-rwxr-xr-x
2024-11-21 20:01
vcs-run
6.75
KB
-rwxr-xr-x
2022-06-03 10:51
vdir
147.8
KB
-rwxr-xr-x
2022-09-20 15:27
vi
3.48
MB
-rwxr-xr-x
2025-02-16 05:23
view
3.48
MB
-rwxr-xr-x
2025-02-16 05:23
vim
3.48
MB
-rwxr-xr-x
2025-02-16 05:23
vim.basic
3.48
MB
-rwxr-xr-x
2025-02-16 05:23
vim.tiny
1.55
MB
-rwxr-xr-x
2025-02-16 05:23
vimdiff
3.48
MB
-rwxr-xr-x
2025-02-16 05:23
vimtutor
2.1
KB
-rwxr-xr-x
2025-02-16 05:23
vmstat
34.72
KB
-rwxr-xr-x
2022-12-19 06:06
w
22.3
KB
-rwxr-xr-x
2022-12-19 06:06
wall
38.3
KB
-rwxr-xr-x
2024-11-21 20:01
watch
26.71
KB
-rwxr-xr-x
2022-12-19 06:06
watchgnupg
18.23
KB
-rwxr-xr-x
2026-01-01 14:54
wc
51.05
KB
-rwxr-xr-x
2022-09-20 15:27
wdctl
70.34
KB
-rwxr-xr-x
2024-11-21 20:01
webmin
13.29
KB
-rwxr-xr-x
2026-07-17 21:17
wget
459.36
KB
-rwxr-xr-x
2025-03-03 13:32
whatis
51.29
KB
-rwxr-xr-x
2023-03-12 22:23
whereis
30.77
KB
-rwxr-xr-x
2024-11-21 20:01
which
946
B
-rwxr-xr-x
2023-07-28 23:46
which.debianutils
946
B
-rwxr-xr-x
2023-07-28 23:46
whiptail
26.75
KB
-rwxr-xr-x
2023-01-31 14:53
who
59.02
KB
-rwxr-xr-x
2022-09-20 15:27
whoami
38.86
KB
-rwxr-xr-x
2022-09-20 15:27
write
22.31
KB
-rwxr-xr-x
2024-11-21 20:01
write-mime-multipart
3.54
KB
-rwxr-xr-x
2022-06-03 10:51
wsrep_sst_backup
2.39
KB
-rwxr-xr-x
2026-06-27 11:11
wsrep_sst_common
67.46
KB
-rwxr-xr-x
2026-06-27 11:11
wsrep_sst_mariabackup
49.28
KB
-rwxr-xr-x
2026-06-27 11:11
wsrep_sst_mysqldump
8.11
KB
-rwxr-xr-x
2026-06-27 11:11
wsrep_sst_rsync
29.92
KB
-rwxr-xr-x
2026-06-27 11:11
wsrep_sst_rsync_wan
29.92
KB
-rwxr-xr-x
2026-06-27 11:11
www-browser
1.86
MB
-rwxr-xr-x
2023-01-15 14:21
x86_64
26.58
KB
-rwxr-xr-x
2024-11-21 20:01
xargs
70.45
KB
-rwxr-xr-x
2023-01-08 18:07
xsubpp
5.05
KB
-rwxr-xr-x
2025-08-29 12:09
xz
82.7
KB
-rwxr-xr-x
2026-06-26 13:13
xzcat
82.7
KB
-rwxr-xr-x
2026-06-26 13:13
xzcmp
7.25
KB
-rwxr-xr-x
2026-06-26 13:13
xzdiff
7.25
KB
-rwxr-xr-x
2026-06-26 13:13
xzegrep
10.09
KB
-rwxr-xr-x
2026-06-26 13:13
xzfgrep
10.09
KB
-rwxr-xr-x
2026-06-26 13:13
xzgrep
10.09
KB
-rwxr-xr-x
2026-06-26 13:13
xzless
1.77
KB
-rwxr-xr-x
2026-06-26 13:13
xzmore
2.14
KB
-rwxr-xr-x
2026-06-26 13:13
yes
38.83
KB
-rwxr-xr-x
2022-09-20 15:27
ypdomainname
22.15
KB
-rwxr-xr-x
2022-12-19 13:33
zcat
1.94
KB
-rwxr-xr-x
2022-04-10 02:22
zcmp
1.64
KB
-rwxr-xr-x
2022-04-10 02:22
zdiff
6.31
KB
-rwxr-xr-x
2022-04-10 02:22
zdump
22.52
KB
-rwxr-xr-x
2026-04-27 20:14
zegrep
29
B
-rwxr-xr-x
2022-04-10 02:22
zff2gff3.pl
684
B
-rwxr-xr-x
2013-11-30 07:54
zfgrep
29
B
-rwxr-xr-x
2022-04-10 02:22
zforce
2.03
KB
-rwxr-xr-x
2022-04-10 02:22
zgrep
7.91
KB
-rwxr-xr-x
2022-04-10 02:22
zipdetails
68.55
KB
-rwxr-xr-x
2025-08-29 12:09
zipgrep
2.89
KB
-rwxr-xr-x
2026-08-16 13:50
zipinfo
175.05
KB
-rwxr-xr-x
2026-08-16 13:50
zless
2.15
KB
-rwxr-xr-x
2022-04-10 02:22
zmore
1.8
KB
-rwxr-xr-x
2022-04-10 02:22
znew
4.47
KB
-rwxr-xr-x
2022-04-10 02:22
zoe-loop
126.62
KB
-rwxr-xr-x
2020-12-22 13:24
zstd
1.22
MB
-rwxr-xr-x
2023-03-18 20:58
zstdcat
1.22
MB
-rwxr-xr-x
2023-03-18 20:58
zstdgrep
3.78
KB
-rwxr-xr-x
2023-03-18 20:58
zstdless
197
B
-rwxr-xr-x
2023-03-18 20:58
zstdmt
1.22
MB
-rwxr-xr-x
2023-03-18 20:58
Save
Rename
#!/bin/sh # -*- Mode: Sh -*- # updateConfFile.sh --- # Author : Manoj Srivastava ( srivasta@glaurung.green-gryphon.com ) # Created On : Fri Feb 1 03:41:47 2002 # Created On Node : glaurung.green-gryphon.com # Last Modified By : Manoj Srivastava # Last Modified On : Tue Jun 6 09:48:22 2006 # Last Machine Used: glaurung.internal.golden-gryphon.com # Update Count : 186 # Status : Unknown, Use with caution! # HISTORY : # Description : # # This script attempts to provide conffile like handling for files not # shipped in a Debian package, but handled by the postinst. Using this # script, one may ship a bunch of default cofiguration files somewhere # in /usr (/usr/share/<pkg> is a good location), and maintain files in # /etc. # # The motivation for this script was to provide conffile like handling # for start files for emacs lisp packages (for example, # /etc/emacs21/site-stard.d/50psgml-init.el) These start files are not # shipped with the package, instead, they are installed during the # post installation configuration phase by the script # /usr/lib/emacsen-common/emacs-package-install $package_name. # # This script is meant to be invoked by the packages install script at # /usr/lib/emacsen-common/packages/install/$package_name for each # flavour of installed emacsen by calling it with the proper values of # new file (/usr/share/emacs/site-lisp/<pkg>/<pkg>-init.el), and dest file # (/etc/emacs21/site-stard.d/50<pkg>-init.el)), and it should do the rest. # # make sure we exit on error set -e # set the version and revision progname="$(basename $0)" pversion='Revision: 3.00 ' unset GREP_OPTIONS ###################################################################### ######## ######### ######## Utility functions ######### ######## ######### ###################################################################### setq() { # Variable Value Doc_string if [ "x$2" = "x" ]; then echo >&2 "$progname: Unable to determine $3" exit 1; else if [ "x$VERBOSE" != "x" ]; then echo >&2 "$progname: $3 is $2"; fi eval "$1=\"\$2\""; fi } # Usage: get_file_metadate file_name get_file_metadata() { if [ -e "$1" ]; then # get file modification date without the nanoseconds and timezone info local moddate="$(date +"%F %T" --date $(stat --format '@%Y' "$1"))" # print file_name user.group permissions above_date stat --format "%n %U.%G 0%a $moddate" "$1" else echo "/dev/null" fi } # Runs the diff command with approrpiate arguments # Usage run_diff diff|sdiff diff_opts old_file new_file run_diff() { local diff_cmd="$1" local diff_opt="$2" local old_file="$3" local new_file="$4" # Note: get_file_metadata not in quotes to ignore "\n" characters local old_file_label="$(get_file_metadata "$old_file")" local new_file_label="$(get_file_metadata "$new_file")" [ -e "$old_file" ] || old_file=/dev/null [ -e "$new_file" ] || new_file=/dev/null if [ "$diff_cmd" = "diff" ] ; then diff "$diff_opt" --label "$old_file_label" "$old_file" \ --label "$new_file_label" "$new_file" || true elif [ "$diff_cmd" = "sdiff" ] ; then # unfortunatelly the sdiff command does not support --label option local out="$(sdiff "$diff_opt" "$old_file" "$new_file")" || true [ -z "$out" ] || printf "Old file: %s\nNew file: %s\n\n%s" \ "$old_file_label" "$new_file_label" "$out" else echo "Unknown diff command: $diff_cmd" >&2 exit 1 fi } # Use debconf to show the differences # Usage: show_diff actual_file_differences file_stat_differences show_diff() { if [ -z "$1" ]; then DIFF="There are no non-white space differences in the files." else if [ 99999 -lt "$(echo $1 | wc -c | awk '{print $1; }')" ]; then DIFF="The differences between the files are too large to display." else DIFF="$1" fi fi if [ "$DEBCONF_OK" = "YES" ] && [ "$DEBIAN_HAS_FRONTEND" ]; then templ=ucf/show_diff db_capb escape db_subst $templ DIFF "$(printf %s "$DIFF" | debconf-escape -e)" db_fset $templ seen false db_input critical $templ || true db_go || true db_get $templ # may contain sensitive information, so clear # immediatly after use so it is never written # to disk db_subst $templ DIFF "" db_reset $templ db_capb else if [ -z "$my_pager" ]; then echo "$DIFF" | sensible-pager else echo "$DIFF" | $my_pager fi fi } withecho () { echo "$@" >&2 "$@" } usageversion () { cat >&2 <<END Debian GNU/Linux $progname $pversion. Copyright (C) 2002-2005 Manoj Srivastava. This is free software; see the GNU General Public Licence for copying conditions. There is NO warranty. Usage: $progname [options] new_file destination Options: -h, --help print this message -s foo, --src-dir foo Set the src dir (historical md5sums live here) --sum-file bar Force the historical md5sums to be read from this file. Overrides any setting of --src-dir. -d[n], --debug=[n] Set the Debug level to N. Please note there must be no spaces before the debug level -n, --no-action Dry run. No action is actually taken. -P foo, --package foo Don't follow dpkg-divert diversions by package foo. -v, --verbose Make the script verbose --three-way Register this file in the cache, and turn on the diff3 option allowing the merging of maintainer changes into a (potentially modified) local configuration file. ) --state-dir bar Set the state directory to bar instead of the default '/var/lib/ucf'. Used mostly for testing. --debconf-ok Indicate that it is ok for ucf to use an already running debconf instance for prompting. --debconf-template bar Specify an alternate, caller-provided debconf template to use for prompting. Usage: $progname -p destination -p, --purge Remove any reference to destination from records By default, the directory the new_file lives in is assumed to be the src-dir, which is where we look for any historical md5sums. END } ###################################################################### ######## ######### ######## file and hash save/restore functions ######### ######## ######### ###################################################################### purge_md5sum () { for i in $(/usr/bin/seq 6 -1 0); do if [ -e "${statedir}/hashfile.${i}" ]; then if [ "X$docmd" = "XYES" ]; then cp -pf "${statedir}/hashfile.${i}" \ "${statedir}/hashfile.$(($i+1))" else echo cp -pf "${statedir}/hashfile.${i}" \ "${statedir}/hashfile.$(($i+1))" fi fi done if [ -e "$statedir/hashfile" ]; then if [ "X$docmd" = "XYES" ]; then cp -pf "$statedir/hashfile" "$statedir/hashfile.0" else echo cp -pf "$statedir/hashfile" "$statedir/hashfile.0" fi if [ "X$docmd" = "XYES" ]; then set +e if [ "X$VERBOSE" != "X" ]; then echo >&2 "grep -Ev [[:space:]]${safe_dest_file}$ $statedir/hashfile" grep -Ev "[[:space:]]${safe_dest_file}$" "$statedir/hashfile" >&2 \ || true; fi #echo "grep -Ev [[:space:]]${safe_dest_file}$ $statedir/hashfile" grep -Ev "[[:space:]]${safe_dest_file}$" "$statedir/hashfile" > \ "$statedir/hashfile.tmp" || true; if [ "X$docmd" = "XYES" ]; then mv -f "$statedir/hashfile.tmp" "$statedir/hashfile" else echo mv -f "$statedir/hashfile.tmp" "$statedir/hashfile" fi set -e fi fi test -n "$VERBOSE" && echo >&2 "The cache file is $cached_file" if [ ! -z "$cached_file" -a -f "$statedir/cache/$cached_file" ]; then $action rm -f "$statedir/cache/$cached_file" fi } replace_md5sum () { for i in $(/usr/bin/seq 6 -1 0); do if [ -e "${statedir}/hashfile.${i}" ]; then if [ "X$docmd" = "XYES" ]; then cp -pf "${statedir}/hashfile.${i}" \ "${statedir}/hashfile.$(($i+1))" else echo cp -pf "${statedir}/hashfile.${i}" \ "${statedir}/hashfile.$(($i+1))" fi fi done if [ -e "$statedir/hashfile" ]; then if [ "X$docmd" = "XYES" ]; then cp -pf "$statedir/hashfile" "$statedir/hashfile.0" else echo cp -pf "$statedir/hashfile" "$statedir/hashfile.0" fi if [ "X$docmd" = "XYES" ]; then set +e if [ "X$VERBOSE" != "X" ]; then echo >&2 "(grep -Ev \"[[:space:]]${safe_dest_file}$\" \"$statedir/hashfile\";" grep -Ev "[[:space:]]${safe_dest_file}$" "$statedir/hashfile" >&2 || true; md5sum "$orig_new_file" | sed "s|$orig_new_file|$dest_file|" >&2; fi grep -Ev "[[:space:]]${safe_dest_file}$" "$statedir/hashfile" > \ "$statedir/hashfile.tmp" || true; md5sum "$orig_new_file" | sed "s|$orig_new_file|$dest_file|" >> \ "$statedir/hashfile.tmp"; mv -f "$statedir/hashfile.tmp" "$statedir/hashfile" set -e else echo "(grep -Ev \"[[:space:]]${safe_dest_file}$\" \"$statedir/hashfile\"" echo " md5sum \"$orig_new_file\" | sed \"s|$orig_new_file|$dest_file|\"; " echo ") | sort > \"$statedir/hashfile\"" fi else if [ "X$docmd" = "XYES" ]; then md5sum "$orig_new_file" | sed "s|$orig_new_file|$dest_file|" > \ "$statedir/hashfile" else echo " md5sum \"$orig_new_file\" | sed \"s|$orig_new_file|$dest_file|\" >" \ "\"$statedir/hashfile\"" fi fi file_size=$(stat -c '%s' "$orig_new_file") if [ "X$THREEWAY" != "X" ] || [ "$file_size" -lt 25600 ]; then $action cp -pf "$orig_new_file" "$statedir/cache/$cached_file" fi # cp -pf "$orig_new_file" "$dest_file.${DIST_SUFFIX}" } replace_conf_file () { # do not mangle $dest_file since it's the one registered in the hashfile # or we have been ask to register real_file="$dest_file" if [ -L "$dest_file" ]; then real_file="$(readlink -nf $dest_file || :)" if [ "x$real_file" = "x" ]; then echo >&2 "$dest_file is a broken symlink!" $action rm -f "$dest_file"; real_file="$dest_file" fi fi if [ -e "$real_file" ]; then if [ -z "$RETAIN_OLD" ]; then #echo "Saving ${real_file}.${OLD_SUFFIX}, in case." if [ "x$VERBOSE" != "x" ]; then echo >&2 "Not saving ${real_file}, since it was unmodified" fi else $action cp -pf $selinux "${real_file}" "${real_file}.${OLD_SUFFIX}" fi fi if [ -e "${real_file}" ]; then # Do not change the permissions and attributes of the destination $action cp -f $selinux "$new_file" "${real_file}" else # No destination file exists $action cp -pf $selinux "$new_file" "${real_file}" fi replace_md5sum; } # Escape single quotes in the arguments passed in quote_single() { printf "%s\n" "$1" | sed -e "s,','\\\\'',g" } ###################################################################### ######## ######### ######## Command line args ######### ######## ######### ###################################################################### # # Long term variables# # docmd='YES' action='withecho' action= selinux='' DEBUG=0 VERBOSE='' statedir='/var/lib/ucf'; THREEWAY= DIST_SUFFIX="ucf-dist" NEW_SUFFIX="ucf-new" OLD_SUFFIX="ucf-old" ERR_SUFFIX="merge-error" # save up the cmdline with proper quoting/escaping saved= for arg in "$@"; do saved="${saved:+$saved }'$(quote_single "$arg")'" done # Note that we use `"$@"' to let each command-line parameter expand to a # separate word. The quotes around `$@' are essential! # We need TEMP as the `eval set --' would nuke the return value of getopt. TEMP=$(getopt -a -o hs:d::D::npP:Zv -n "$progname" \ --long help,src-dir:,sum-file:,dest-dir:,debug::,DEBUG::,no-action,package:,purge,verbose,three-way,debconf-ok,debconf-template:,state-dir: \ -- "$@") # Note the quotes around `$TEMP': they are essential! eval set -- "$TEMP" while true ; do case "$1" in -h|--help) usageversion; exit 0 ;; -n|--no-action) action='echo'; docmd='NO'; shift ;; -v|--verbose) VERBOSE=1; shift ;; -P|--package) opt_package="$2"; shift 2 ;; -s|--src-dir) opt_source_dir="$2"; shift 2 ;; --sum-file) opt_old_mdsum_file="$2"; shift 2 ;; --state-dir) opt_state_dir="$2"; shift 2 ;; --debconf-template) override_template="$2"; shift 2 ;; -D|-d|--debug|--DEBUG) # d has an optional argument. As we are in quoted mode, # an empty parameter will be generated if its optional # argument is not found. case "$2" in "") setq DEBUG 1 "The Debug value"; shift 2 ;; *) setq DEBUG "$2" "The Debug value"; shift 2 ;; esac ;; -p|--purge) PURGE=YES; shift ;; --three-way) THREEWAY=YES; shift ;; --debconf-ok) DEBCONF_OK=YES; shift ;; -Z) selinux='-Z'; shift ;; --) shift ; break ;; *) echo >&2 "Internal error!" ; exit 1 ;; esac done ###################################################################### ######## ######### ######## Sanity checking ######### ######## ######### ###################################################################### # Need to run as root, or else the if test "$(id -u)" != 0; then if [ "$docmd" = "YES" ]; then echo "$progname: Need to be run as root." >&2 echo "$progname: Setting up no action mode." >&2 action='echo'; docmd='NO'; fi fi if [ "X$PURGE" = "XYES" ]; then if [ $# != 1 ]; then echo >&2 "*** ERROR: Need exactly one argument when purging, got $#"; echo >&2 "" usageversion; exit 2 ; fi temp_dest_file="$1"; if [ -e "$temp_dest_file" ]; then setq dest_file "$(readlink -q -m $temp_dest_file)" "The Destination file"; else setq dest_file "$temp_dest_file" "The Destination file"; fi else if [ $# != 2 ]; then echo >&2 "*** ERROR: Need exactly two arguments, got $#"; echo >&2 "" usageversion; exit 2 ; fi temp_new_file="$1"; temp_dest_file="$2"; if [ ! -e "${temp_new_file}" ]; then echo >&2 "Error: The new file ${temp_new_file} does not exist!"; exit 1; fi setq new_file "$(readlink -q -m $temp_new_file)" "The new file"; if [ -e "$temp_dest_file" ]; then setq dest_file "$(readlink -q -m $temp_dest_file)" "The Destination file"; else setq dest_file "$temp_dest_file" "The Destination file"; fi fi # Follow dpkg-divert as though we are installed as part of $opt_package divert_line=$(dpkg-divert --listpackage "$dest_file") if [ -n "$divert_line" ]; then # name of the package or 'LOCAL' for a local diversion divert_package="$divert_line" if [ "$divert_package" != "$opt_package" ]; then dest_file=$(dpkg-divert --truename "$dest_file") fi fi safe_dest_file=$(echo "$dest_file" | perl -nle 'print "\Q$_\E\n"') ###################################################################### ######## ######### ######## Set Default Values ######### ######## ######### ###################################################################### # Load site defaults and over rides. if [ -f /etc/ucf.conf ]; then . /etc/ucf.conf fi # Command line, env variable, config file, or default if [ ! "x$opt_source_dir" = "x" ]; then setq source_dir "$opt_source_dir" "The Source directory" elif [ ! "x$UCF_SOURCE_DIR" = "x" ]; then setq source_dir "$UCF_SOURCE_DIR" "The Source directory" elif [ ! "x$conf_source_dir" = "x" ]; then setq source_dir "$conf_source_dir" "The Source directory" else if [ "X$new_file" != "X" ]; then setq source_dir "$(dirname $new_file)" "The Source directory" else setq source_dir "/tmp" "The Source directory" fi fi if [ "X$PAGER" != "X" ] && which "$PAGER" >/dev/null 2>&1 ; then my_pager="$(which $PAGER)"; elif [ -s /usr/bin/pager ] && [ "X$(readlink -e /usr/bin/pager || :)" != "X" ]; then my_pager=/usr/bin/pager elif [ -x /usr/bin/sensible-pager ]; then my_pager=/usr/bin/sensible-pager elif [ -x /bin/more ]; then my_pager=/bin/more else my_pager= fi # Command line, env variable, config file, or default if [ ! "x$opt_state_dir" = "x" ]; then setq statedir "$opt_state_dir" "The State directory" elif [ ! "x$UCF_STATE_DIR" = "x" ]; then setq statedir "$UCF_STATE_DIR" "The State directory" elif [ ! "x$conf_state_dir" = "x" ]; then setq statedir "$conf_state_dir" "The State directory" else setq statedir '/var/lib/ucf' "The State directory" fi # Command line, env variable, config file, or default if [ ! "x$opt_force_conffold" = "x" ]; then setq force_conffold "$opt_force_conffold" "Keep the old file" elif [ ! "x$UCF_FORCE_CONFFOLD" = "x" ]; then setq force_conffold "$UCF_FORCE_CONFFOLD" "Keep the old file" elif [ ! "x$conf_force_conffold" = "x" ]; then setq force_conffold "$conf_force_conffold" "Keep the old file" else force_conffold='' fi # Command line, env variable, config file, or default if [ ! "x$opt_force_conffnew" = "x" ]; then setq force_conffnew "$opt_force_conffnew" "Replace the old file" elif [ ! "x$UCF_FORCE_CONFFNEW" = "x" ]; then setq force_conffnew "$UCF_FORCE_CONFFNEW" "Replace the old file" elif [ ! "x$conf_force_conffnew" = "x" ]; then setq force_conffnew "$conf_force_conffnew" "Replace the old file" else force_conffnew='' fi # Command line, env variable, config file, or default if [ ! "x$opt_force_conffmiss" = "x" ]; then setq force_conffmiss "$opt_force_conffmiss" "Replace any missing files" elif [ ! "x$UCF_FORCE_CONFFMISS" = "x" ]; then setq force_conffmiss "$UCF_FORCE_CONFFMISS" "Replace any missing files" elif [ ! "x$conf_force_conffmiss" = "x" ]; then setq force_conffmiss "$conf_force_conffmiss" "Replace any missing files" else force_conffmiss='' fi if [ -n "$opt_old_mdsum_file" ]; then setq old_mdsum_file "$opt_old_mdsum_file" "The md5sum is found here" elif [ ! "x$UCF_OLD_MDSUM_FILE" = "x" ]; then setq old_mdsum_file "$UCF_OLD_MDSUM_FILE" "The md5sum is found here" elif [ ! "x$conf_old_mdsum_file" = "x" ]; then setq old_mdsum_file "$conf_old_mdsum_file" "Replace the old file" elif [ ! "x${new_file}" = "x" ]; then old_mdsum_file="$source_dir/$(basename ${new_file}).md5sum"; else old_mdsum_file=""; fi ###################################################################### ######## ######### ######## More Sanity checking ######### ######## ######### ###################################################################### if [ "X$force_conffold" != "X" -a "X$force_conffnew" != "X" ]; then echo >&2 "Error: Only one of force_conffold and force_conffnew should"; echo >&2 " be set"; exit 1; fi # VERBOSE of 0 is supposed to be the same as not setting VERBOSE if [ "X$VERBOSE" = "X0" ]; then VERBOSE='' fi # if [ -e "$statedir/hashfile" -a ! -w "$statedir/hashfile" ]; then echo >&2 "ucf: do not have write privilege to the state data" if [ "X$docmd" = "XYES" ]; then exit 1; fi fi if [ ! -d $statedir/cache ]; then $action mkdir -p $statedir/cache ; fi # test and see if this file exists in the database if [ -e "$statedir/hashfile" ]; then if [ "X$VERBOSE" != "X" ]; then echo >&2 "The hash file exists" echo >&2 "grep -E" "[[:space:]]${safe_dest_file}$" "$statedir/hashfile" grep -E "[[:space:]]${safe_dest_file}$" "$statedir/hashfile" >&2 || true fi lastsum=$(grep -E "[[:space:]]${safe_dest_file}$" "$statedir/hashfile" | \ awk '{print $1;}' ) fi if [ ! "x${new_file}" = "x" ]; then old_mdsum_dir="$source_dir/"$(basename "${new_file}")".md5sum.d"; else old_mdsum_dir=""; fi cached_file="$(echo $dest_file | tr / :)" ###################################################################### ######## ######### ######## Debugging dump ######### ######## ######### ###################################################################### if [ $DEBUG -gt 0 ]; then cat >&2 <<EOF The new start file is \`$new_file\' The destination is \`$dest_file\' (\`$safe_dest_file\') The history is kept under \'$source_dir\' The file may be cached at \'$statedir/cache/$cached_file\' EOF if [ -s "$dest_file" ]; then echo "The destination file exists, and has md5sum:" md5sum "$dest_file" else echo "The destination file does not exist." fi if [ "X$lastsum" != "X" ]; then echo "The old md5sum exists, and is:" echo "$lastsum" else echo "The old md5sum does not exist." if [ -d "$old_mdsum_dir" -o -f "$old_mdsum_file" ]; then echo "However, there are historical md5sums around." fi fi if [ -e "$new_file" ]; then echo "The new file exists, and has md5sum:" md5sum "$new_file" else echo "The new file does not exist." fi if [ -d "$old_mdsum_dir" ]; then echo "The historical md5sum dir $old_mdsum_dir exists" elif [ -f "$old_mdsum_file" ]; then echo "The historical md5sum file $old_mdsum_file exists" else echo "Historical md5sums are not available" fi fi ###################################################################### ######## ######### ######## Short circuit if we are purging ######### ######## ######### ###################################################################### if [ "X$PURGE" = "XYES" ]; then if [ "X$VERBOSE" != "X" ]; then echo >&2 "Preparing to purge ${dest_file}" fi purge_md5sum; exit 0; fi # now we can restore $@ eval set -- "$saved" ###################################################################### ######## ######### ######## DebConf stuff ######### ######## ######### ###################################################################### # Is debconf already running? Kinda tricky, because it will be after the # confmodule is sourced, so only test before that. if [ -z "$DEBCONF_ALREADY_RUNNING" ]; then if [ "$DEBIAN_HAS_FRONTEND" ]; then DEBCONF_ALREADY_RUNNING='YES' else DEBCONF_ALREADY_RUNNING='NO' fi fi export DEBCONF_ALREADY_RUNNING if [ -z "$DEBCONF_OK" ]; then if [ "$DEBCONF_ALREADY_RUNNING" = 'YES' ]; then DEBCONF_OK='NO' else DEBCONF_OK='YES' fi fi # Time to start nagging the users who call ucf without debconf-ok if [ "$DEBCONF_ALREADY_RUNNING" = 'YES' ] && [ "$DEBCONF_OK" = NO ]; then # Commented out for now, uncomment after a while to begin nagging # maintainers to fix their scripts. cat \ <<END *** WARNING: ucf was run from a maintainer script that uses debconf, but the script did not pass --debconf-ok to ucf. The maintainer script should be fixed to not stop debconf before calling ucf, and pass it this parameter. For now, ucf will revert to using old-style, non-debconf prompting. Ugh! Please inform the package maintainer about this problem. END fi # Start up debconf or at least get the db_* commands available if [ -e /usr/share/debconf/confmodule ]; then if test "$(id -u)" = 0; then . /usr/share/debconf/confmodule # Load our templates, just in case our template has # not been loaded or the Debconf DB lost or corrupted # since then, but only if it is OK to use debconf. if [ "$DEBCONF_OK" = 'YES' ]; then db_x_loadtemplatefile "$(dpkg-query --control-path ucf templates)" ucf fi else echo >&2 "$progname: Not loading confmodule, since we are not running as root." fi # Only set the title if debconf was not already running. # If it was running, then we do not want to clobber the # title used for configuring the whole package with debconf. if [ "$DEBCONF_ALREADY_RUNNING" = 'NO' ]; then if ! db_settitle ucf/title 2>/dev/null; then # Older debconf that does not support that command. if test "$(id -u)" = 0; then db_title "Modified configuration file" else echo >&2 "$progname: Not changing title, since we are not running as root." fi fi fi fi ###################################################################### ######## ######### ######## Start Processing ######### ######## ######### ###################################################################### orig_new_file="$new_file" # Since sometimes we replace the newfile below newsum=$(md5sum "$new_file" | awk '{print $1}') # Determine the action for the current file. The default is to ask, # with non-replacement being the norm. # If the config dir exists # if file in always overwrite, state +=1; # fi # if file in never overwrite, state +=2; # fi # if file in ask; state +=4 # fi # if state == 0; then state = default # if state >= 4; ask # if state == 3; ask # if state == 2; exit # if state == 1; then replace_conffile; exit ###################################################################### ######## ######### ######## Do the replacement ######### ######## ######### ###################################################################### # Step 1: If we have no record of this file, and dest file # does, We need to determine how to initialize the # ${old_mdsum_prefix}.old file.. if [ -e "$dest_file" ]; then destsum=$(md5sum "$dest_file" | awk '{print $1}'); if [ "X$lastsum" = "X" ]; then # a: If we have a directory containing historical md5sums of this # file in question, we should look and see if the currently # installed file matches any of the old md5sums; in which case # it can be silently replaced. if [ -d "$old_mdsum_dir" -o -f "$old_mdsum_file" ]; then if [ -d "$old_mdsum_dir" ]; then for file in ${old_mdsum_dir}/*; do oldsum="$(awk '{print $1}' $file)"; if [ "$oldsum" = "$destsum" ]; then if [ "X$force_conffold" = "X" ]; then # Bingo! replace, set the md5sum, and we are done if [ "X$VERBOSE" != "X" ]; then echo >&2 \ "Replacing config file $dest_file with new version" fi replace_conf_file; exit 0; else replace_md5sum; cp -pf "$orig_new_file" "$dest_file.${DIST_SUFFIX}" exit 0; fi fi done elif [ -f "$old_mdsum_file" ]; then oldsum=$(grep -E "^${destsum}" "$old_mdsum_file" || true) if [ "X$oldsum" != "X" ]; then # Bingo if [ "X$force_conffold" = "X" ]; then if [ "X$VERBOSE" != "X" ]; then echo >&2 \ "Replacing config file $dest_file with new version" fi replace_conf_file; exit 0; else replace_md5sum; cp -pf "$orig_new_file" "$dest_file.${DIST_SUFFIX}" exit 0; fi fi fi # Well, nothing matched. We now check to see if the # maintainer has an opinion on how to set the ``md5sum of the # previously installed version'', since we have no way of # determining that automatically. Please note that unless # there are limited number of previously released packages # (like just one), the maintainer is also making a guess at # this point by supplying a historical md5sum default file. if [ "X$VERBOSE" != "X" ]; then echo >&2 "Historical md5sums did not match." fi if [ -d "$old_mdsum_dir" ]; then if [ -e "${old_mdsum_dir}/default" ]; then if [ "X$VERBOSE" != "X" ]; then echo >&2 "However, a default entry exists, using it." fi lastsum="$(awk '{print $1;}' ${old_mdsum_dir}/default)" do_replace_md5sum=1; fi elif [ -f "$old_mdsum_file" ]; then oldsum=$(grep -E "[[:space:]]default$" "$old_mdsum_file" | \ awk '{print $1;}') if [ "X$oldsum" != "X" ]; then # Bingo lastsum=$oldsum; do_replace_md5sum=1; fi fi fi # At this point, we are almost certain that either the # historical record of md5sums is not complete, or the user has # changed the configuration file. Rather than guessing and # chosing one of the historical md5sums, we fall through to the # solution used if there had been no historical md5sums # directory/file. if [ "X$lastsum" = "X" ]; then # b: We do not have a historical list of md5sums, or none # matched, and we still need to initialize the # ${old_mdsum_prefix}.old file. We can't determine whther or # not they made any changes, so we err on the side of caution # and ask' if [ "X$VERBOSE" != "X" ]; then echo >&2 "No match found, we shall ask." fi lastsum='AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA'; fi # the old md5sum file does not exist, and the historical # record failed fi # the old md5sum file does not exist (bug)) else # "$dest_file" does not exist # Step 2: If destfile does not exist, create it, set the file # "${old_mdsum_prefix}.old" to the md5sum of the new file, and we # are done if [ "X$lastsum" = "X" ]; then # Ok, so there is no indication that the package was ever # installed on this machine. echo >&2 "" echo >&2 "Creating config file $dest_file with new version" replace_conf_file; exit 0; elif [ "$lastsum" = "$newsum" ]; then # OK, new version of the file is the same as the last version # we saw. Since the user apparently has deleted the file, # nothing needs be done, unless we have been told differently if [ "X$force_conffmiss" != "X" ]; then echo >&2 "" echo >&2 "Recreating deleted config file $dest_file with new version, as asked" replace_conf_file; exit 0; else echo >&2 "Not replacing deleted config file $dest_file"; fi else # OK. New upstream version. if [ "X$force_conffmiss" != "X" ]; then # User has said to replace missing files, so we do so, no # questions asked. echo >&2 "" echo >&2 "Recreating deleted config file $dest_file with new version, as asked" replace_conf_file; exit 0; else # Even though the user has deleted this file, they should # be asked now, unless specified otherwise. if [ "X$force_conffold" = "X" ]; then destsum='AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA'; else exit 0; fi fi fi fi # Here, the destfile exists. # step 3: If the old md5sum and the md5sum of the new file # do not match, we need to take action. if [ "$lastsum" = "$newsum" ]; then if [ "X$VERBOSE" != "X" ]; then echo >&2 "md5sums match, nothing needs be done." fi if [ "X$do_replace_md5sum" != "X" ]; then replace_md5sum; fi exit 0; # Hah. Match. We are done. fi # a: If the md5sum of the dest file is the same as lastsum, replace the # destfile, saying we are replacing old config files if [ "$destsum" = "$lastsum" ]; then if [ "X$force_conffold" = "X" ]; then echo >&2 "Replacing config file $dest_file with new version" replace_conf_file; exit 0; else replace_md5sum; cp -pf "$orig_new_file" "$dest_file.${DIST_SUFFIX}" exit 0; fi else # b: If the md5sum of the dest file differs from lastsum, we need to ask # the user what action to take. if [ "X$force_conffnew" != "X" ]; then echo >&2 "Replacing config file $dest_file with new version" echo >&2 "since you asked for it." if [ "$destsum" = "$newsum" ]; then echo >&2 "The new and the old files are identical, AFAICS" else echo >&2 "The new and the old files are different" fi replace_conf_file; exit 0; fi if [ "X$force_conffold" != "X" ]; then replace_md5sum; cp -pf "$orig_new_file" "$dest_file.${DIST_SUFFIX}" exit 0; fi # c: If the destination file is the same as the new maintianer provided one, # we need do nothing. if [ "$newsum" = "$destsum" ]; then if [ "X$VERBOSE" != "X" ]; then echo >&2 "md5sums of the file in place matches, nothing needs be done." fi replace_md5sum; exit 0; # Hah. Match. We are done. fi done='NO'; while [ "X$done" = "XNO" ]; do if [ "$DEBCONF_OK" = "YES" ] && [ "$DEBIAN_HAS_FRONTEND" ]; then # Use debconf to prompt. if [ -e "$statedir/cache/$cached_file" ] && [ "X$THREEWAY" != "X" ]; then templ=ucf/changeprompt_threeway else templ=ucf/changeprompt fi if [ "X$override_template" != "X" ]; then choices="$(db_metaget $templ Choices-C)" choices2="$(db_metaget $override_template Choices-C)" if [ "$choices" = "$choices2" ]; then templ=$override_template fi fi db_fset "$templ" seen false db_reset "$templ" db_subst "$templ" FILE "$dest_file" db_subst "$templ" NEW "$new_file" db_subst "$templ" BASENAME "$(basename $dest_file)" db_input critical "$templ" || true if ! db_go; then # The current ucf interface does not provide a way for it # to tell its caller that the user chose to back up. # However, we could get here, if the caller turned on # debconf's backup capb. The best thing to do seems to be # to ignore requests to back up. continue fi db_get "$templ" ANSWER="$RET" else echo >&2 "Need debconf to interact" exit 2 ######################################################################################## # # Prompt without using debconf. # # cat >&2 <<EOPRMT # # Configuration file \`$dest_file' # # ==> File on system created by you or by a script. # # ==> File also in package provided by package maintainer. # # What would you like to do about it ? Your options are: # # Y or I : install the package maintainer's version # # N or O : keep your currently-installed version # # D : show the differences between the versions # # S : show the side-by-side differences between the versions # # EOPRMT # # if [ "X$THREEWAY" != "X" -a -e "$statedir/cache/$cached_file" ]; then # # cat >&2 <<EOTD # # 3 or T : show a three way difference between current, older, # # and new versions of the file # # M : Do a 3 way merge between current, older, # # and new versions of the file [Very Experimental] # # EOTD # # fi # # cat >&2 <<EOPEND # # Z : start a new shell to examine the situation # # The default action is to keep your current version. # # EOPEND # # if [ "X$THREEWAY" != "X" -a -e "$statedir/cache/$cached_file" ]; then # # echo -n >&2 "*** " $(basename "$dest_file") \ # # " (Y/I/N/O/D/3/T/M/Z) [default=N] ?" # # else # # echo -n >&2 "*** " $(basename "$dest_file") \ # # " (Y/I/N/O/D/Z) [default=N] ?" # # fi # # read -e ANSWER </dev/tty # ######################################################################################## fi case "$ANSWER" in install_new|y|Y|I|i) echo >&2 "Replacing config file $dest_file with new version" RETAIN_OLD=YES replace_conf_file; exit 0; ;; diff|D|d) DIFF="$(run_diff diff -uBbwt "$dest_file" "$new_file")" show_diff "$DIFF" ;; sdiff|S|s) DIFF="$(run_diff sdiff -BbW "$dest_file" "$new_file")" show_diff "$DIFF" ;; diff_threeway|3|t|T) if [ -e "$statedir/cache/$cached_file" \ -a "X$THREEWAY" != "X" ]; then if [ -e "$dest_file" ]; then DIFF="$(diff3 -L Current -L Older -L New -A \ "$dest_file" "$statedir/cache/$cached_file" \ "$new_file")" || true else DIFF="$(diff3 -L Current -L Older -L New -A \ /dev/null "$statedir/cache/$cached_file" \ "$new_file")" || true fi show_diff "$DIFF" else DIFF="$(run_diff diff -uBbwt "$dest_file" "$new_file")" show_diff "$DIFF" fi ;; merge_threeway|M|m) echo >&2 "Merging changes into the new version" if [ -e "$statedir/cache/$cached_file" \ -a "X$THREEWAY" != "X" ]; then ret=0 diff3 -L Current -L Older -L New -m \ "$dest_file" "$statedir/cache/$cached_file" \ "$new_file" > "$dest_file.${NEW_SUFFIX}" || ret=$? case "$ret" in 0) new_file="$dest_file.${NEW_SUFFIX}" RETAIN_OLD=YES replace_conf_file rm -f "$dest_file.${NEW_SUFFIX}" # don't need this around no mo' exit 0 ;; *) mv "$dest_file.${NEW_SUFFIX}" "$dest_file.${ERR_SUFFIX}" db_subst ucf/conflicts_found dest_file "$dest_file" db_subst ucf/conflicts_found ERR_SUFFIX "${ERR_SUFFIX}" db_input critical ucf/conflicts_found || true db_go || true ;; esac else replace_conf_file rm -f "$dest_file.${NEW_SUFFIX}" # don't need this around no mo' exit 0 fi ;; shell|Z|z) # We explicitly connect STDIN and STDOUT to the # script's controlling terminal, so even if STDIN is # fed by a pipe, as is the case when run from # /usr/bin/debconf, the shell should be fully # functional. However, the test for a controlling # terminal uses /usr/bin/tty, which consults only # STDIN. As far as I can tell, when run from debconf, # ucf will _never_ use the current terminal. If the # goal is to check for access to a terminal, the test # should be for foreground process group membership, # not a terminal connected to STDIN (tty -s), and not # a terminal it doesn't necessarily own (tty -s # </dev/tty). The easiest way do this from a shell is # probably with /bin/ps. if ps -o stat= --ppid $$ | grep -q '+'; then export UCF_CONFFILE_OLD="$dest_file" export UCF_CONFFILE_NEW="$new_file" bash >/dev/tty </dev/tty || true elif [ -n "$DISPLAY" ]; then x-terminal-emulator || true else # Don't know what to do echo >&2 "No terminal, and no DISPLAY set, can't fork shell." sleep 3; fi ;; keep_current|n|N|o|O|'') replace_md5sum; cp -pf "$orig_new_file" "$dest_file.${DIST_SUFFIX}" exit 0; ;; *) if [ "$DEBCONF_OK" = "YES" ]; then echo "Error: unknown response from debconf:'$RET'" >&2 exit 1 else echo echo "Please answer with one of the single letters listed." >&2 echo fi esac done fi db_stop exit 0;